// DEFINE SOME CONSTANTS
const int cGoldAmtDwarven=1000;
const int cGoldAmtTiny=1500;
const int cGoldAmtSmall=3000;
const int cGoldAmtLarge=6000;

const int cVeryShort=3;
const int cShort=10;
const int cMedium=20;
const int cLong=40;
const int cVeryLong=80;

// GLOBALS ***************************************************
int MapSkin = 1;
int SeaOrLand = 1;  // SEA=1 LAND=0
float SeaLevel = -6;
int WaterOnMap = 0;
int failCount=0;
int OnIsland=1;


// DECLARE OUR CONSTRAINTS GLOBAL SO WE CAN USE IN FUNCTIONS
// Keep Things Off The Map Edges
int avoidMapEdgesVeryShort=cVeryShort;
int avoidMapEdgesShort=cShort;
int avoidMapEdgesMedium=cMedium;
int avoidMapEdgesLong=cLong;
int avoidMapEdgesVeryLong=cVeryLong;

// Used For Various Land Masses
int avoidLandAreaShort=cShort;
int avoidLandAreaMedium=cMedium;
int avoidLandAreaLong=cLong;

// Used For Various Cliffs/Gorges
int avoidCliffsGorgesShort=cShort;
int avoidCliffsGorgesMedium=cMedium;
int avoidCliffsGorgesLong=cLong;

// Animals
int avoidAnimalsShort=cShort;
int avoidAnimalsMedium=cMedium;
int avoidAnimalsLong=cLong;

// Player Areas Constraint
int avoidPlayerAreasVeryShort=cVeryShort;
int avoidPlayerAreasShort=cShort;
int avoidPlayerAreasMedium=cMedium;
int avoidPlayerAreasLong=cLong;
int avoidPlayerAreasVeryLong=cVeryLong;

// Lakes Constraint
int avoidLakesVeryShort=cVeryShort;
int avoidLakesShort=cShort;
int avoidLakesMedium=cMedium;
int avoidLakesLong=cLong;
int avoidLakesVeryLong=cVeryLong;

// Town Centers constraint.
int avoidTownCentersShort=cShort;
int avoidTownCentersMedium=cMedium;
int avoidTownCentersLong=cLong;

// Building constraints - Used For Additoinal Settlements
int avoidBuildingsShort=cShort;
int avoidBuildingsMedium=cMedium;
int avoidBuildingsLong=cLong;
int avoidBuildingsVeryLong=cVeryLong;

// Gold
int avoidGoldShort=cShort;
int avoidGoldMedium=cMedium;
int avoidGoldLong=cLong;

// Relics
int avoidRelicShort=cShort;
int avoidRelicMedium=cMedium;
int avoidRelicLong=cLong;

// Avoid impassable land
int avoidImpassableLandShort=cShort;
int avoidImpassableLandMedium=cMedium;
int avoidImpassableLandLong=cLong;

// Forests
int avoidForestShort=cShort;
int avoidForestMedium=cMedium;
int avoidForestLong=cLong;

// Avoid Water
int avoidWaterVeryShort=cVeryShort;
int avoidWaterShort=cShort;
int avoidWaterMedium=cMedium;
int avoidWaterLong=cLong;

// Near To Water
int nearShoreLineVeryShort=cVeryShort;
int nearShoreLineShort=cShort;
int nearShoreLineMedium=cMedium;
int nearShoreLineLong=cLong;

// Near Land
int nearLandVeryShort=cVeryShort;
int nearLandShort=cShort;
int nearLandMedium=cMedium;
int nearLandLong=cLong;

// Avoid All Objects
int avoidAllVeryShort=cVeryShort;
int avoidAllShort=cShort;
int avoidAllMedium=cMedium;
int avoidAllLong=cLong;

// Random Tree Id's
int idTree1=0;
int idTree2=0;
int idTree3=0;
int idTree4=0;

// Eruptions
int thiserupt=0;
int erupt1=0; int erupt2=0; int erupt3=0; int erupt4=0;
int erupt5=0; int erupt6=0; int erupt7=0; int erupt8=0;
int erupt9=0; int erupt10=0; int erupt11=0; int erupt12=0;
int geterupt(int p=1) {
   if(p==1) {return(erupt1);} else if(p==2) {return(erupt2);} else if(p==3) {return(erupt3);}
   else if(p==4) {return(erupt4);} else if(p==5) {return(erupt5);} else if(p==6) {return(erupt6);}
   else if(p==7) {return(erupt7);} else if(p==8) {return(erupt8);} else if(p==9) {return(erupt9);}
   else if(p==10) {return(erupt10);} else if(p==11) {return(erupt11);} else if(p==12) {return(erupt12);}
}
void seterupt(int p=1, int v=0) {
   int aid = rmCreateArmy(0,"eruptArmy"+p);
   rmAddUnitsToArmy(0,aid,v);
   if(p==1) {erupt1 = aid;} else if(p==2) {erupt2 = aid;} else if(p==3) {erupt3 = aid;}
   else if(p==4) {erupt4 = aid;} else if(p==5) {erupt5 = aid;} else if(p==6) {erupt6 = aid;}
   else if(p==7) {erupt7 = aid;} else if(p==8) {erupt8 = aid;} else if(p==9) {erupt9 = aid;}
   else if(p==10) {erupt10 = aid;} else if(p==11) {erupt11 = aid;} else if(p==12) {erupt12 = aid;}
}
string eruptloc1=""; string eruptloc2=""; string eruptloc3=""; string eruptloc4="";
string eruptloc5=""; string eruptloc6=""; string eruptloc7=""; string eruptloc8="";
string eruptloc9=""; string eruptloc10=""; string eruptloc11=""; string eruptloc12="";
string geteruptloc(int p=1) {
   if(p==1) {return(eruptloc1);} else if(p==2) {return(eruptloc2);} else if(p==3) {return(eruptloc3);}
   else if(p==4) {return(eruptloc4);} else if(p==5) {return(eruptloc5);} else if(p==6) {return(eruptloc6);}
   else if(p==7) {return(eruptloc7);} else if(p==8) {return(eruptloc8);} else if(p==9) {return(eruptloc9);}
   else if(p==10) {return(eruptloc10);} else if(p==11) {return(eruptloc11);} else if(p==12) {return(eruptloc12);}
}
void seteruptloc(int p=1, string val="") {
   if(p==1) {eruptloc1 = val;} else if(p==2) {eruptloc2 = val;} else if(p==3) {eruptloc3 = val;}
   else if(p==4) {eruptloc4 = val;} else if(p==5) {eruptloc5 = val;} else if(p==6) {eruptloc6 = val;}
   else if(p==7) {eruptloc7 = val;} else if(p==8) {eruptloc8 = val;} else if(p==9) {eruptloc9 = val;}
   else if(p==10) {eruptloc10 = val;} else if(p==11) {eruptloc11 = val;} else if(p==12) {eruptloc12 = val;}
}
float iifF(bool cond=true, float val1=0, float val2=0) {
   if (cond==true) return(val1);
   else return(val2);
}

float min(float val1=0, float val2=0) {
   if (val1>val2) return (val2+0.0);
   else return(val1+0.0);
}
float max(float val1=0, float val2=0) {
   if (val1<val2) return (val2+0.0);
   else return(val1+0.0);
}

/* MATH FUNCTIONS  ************************************/
float sin(float Angle=0) {
   float MyAngle=Angle % 360; //iifF(Angle>360,Angle-360,Angle);
   if (MyAngle<=    0) return(.00000000000000);
   else if (MyAngle<=    5) return(.08715574274766);
   else if (MyAngle<=    10) return(.17364817766693);
   else if (MyAngle<=    15) return(.25881904510252);
   else if (MyAngle<=    20) return(.34202014332567);
   else if (MyAngle<=    25) return(.42261826174070);
   else if (MyAngle<=    30) return(.50000000000000);
   else if (MyAngle<=    35) return(.57357643635105);
   else if (MyAngle<=    40) return(.64278760968654);
   else if (MyAngle<=    45) return(.70710678118655);
   else if (MyAngle<=    50) return(.76604444311898);
   else if (MyAngle<=    55) return(.81915204428899);
   else if (MyAngle<=    60) return(.86602540378444);
   else if (MyAngle<=    65) return(.90630778703665);
   else if (MyAngle<=    70) return(.93969262078591);
   else if (MyAngle<=    75) return(.96592582628907);
   else if (MyAngle<=    80) return(.98480775301221);
   else if (MyAngle<=    85) return(.99619469809175);
   else if (MyAngle<=    90) return(1.00000000000000);
   else if (MyAngle<=    95) return(.99619469809175);
   else if (MyAngle<=    100) return(.98480775301221);
   else if (MyAngle<=    105) return(.96592582628907);
   else if (MyAngle<=    110) return(.93969262078591);
   else if (MyAngle<=    115) return(.90630778703665);
   else if (MyAngle<=    120) return(.86602540378444);
   else if (MyAngle<=    125) return(.81915204428899);
   else if (MyAngle<=    130) return(.76604444311898);
   else if (MyAngle<=    135) return(.70710678118655);
   else if (MyAngle<=    140) return(.64278760968654);
   else if (MyAngle<=    145) return(.57357643635105);
   else if (MyAngle<=    150) return(.50000000000000);
   else if (MyAngle<=    155) return(.42261826174070);
   else if (MyAngle<=    160) return(.34202014332567);
   else if (MyAngle<=    165) return(.25881904510252);
   else if (MyAngle<=    170) return(.17364817766693);
   else if (MyAngle<=    175) return(.08715574274766);
   else if (MyAngle<=    180) return(.00000000000000);
   else if (MyAngle<=    185) return(-.08715574274766);
   else if (MyAngle<=    190) return(-.17364817766693);
   else if (MyAngle<=    195) return(-.25881904510252);
   else if (MyAngle<=    200) return(-.34202014332567);
   else if (MyAngle<=    205) return(-.42261826174070);
   else if (MyAngle<=    210) return(-.50000000000000);
   else if (MyAngle<=    215) return(-.57357643635105);
   else if (MyAngle<=    220) return(-.64278760968654);
   else if (MyAngle<=    225) return(-.70710678118655);
   else if (MyAngle<=    230) return(-.76604444311898);
   else if (MyAngle<=    235) return(-.81915204428899);
   else if (MyAngle<=    240) return(-.86602540378444);
   else if (MyAngle<=    245) return(-.90630778703665);
   else if (MyAngle<=    250) return(-.93969262078591);
   else if (MyAngle<=    255) return(-.96592582628907);
   else if (MyAngle<=    260) return(-.98480775301221);
   else if (MyAngle<=    265) return(-.99619469809175);
   else if (MyAngle<=    270) return(-1.00000000000000);
   else if (MyAngle<=    275) return(-.99619469809175);
   else if (MyAngle<=    280) return(-.98480775301221);
   else if (MyAngle<=    285) return(-.96592582628907);
   else if (MyAngle<=    290) return(-.93969262078591);
   else if (MyAngle<=    295) return(-.90630778703665);
   else if (MyAngle<=    300) return(-.86602540378444);
   else if (MyAngle<=    305) return(-.81915204428899);
   else if (MyAngle<=    310) return(-.76604444311898);
   else if (MyAngle<=    315) return(-.70710678118655);
   else if (MyAngle<=    320) return(-.64278760968654);
   else if (MyAngle<=    325) return(-.57357643635105);
   else if (MyAngle<=    330) return(-.50000000000000);
   else if (MyAngle<=    335) return(-.42261826174070);
   else if (MyAngle<=    340) return(-.34202014332567);
   else if (MyAngle<=    345) return(-.25881904510252);
   else if (MyAngle<=    350) return(-.17364817766693);
   else if (MyAngle<=    355) return(-.08715574274766);
   else if (MyAngle<=    360) return(.00000000000000);
}
float cos(float Angle=0) {
   float MyAngle=iifF(Angle>360,Angle-360,Angle);
   if (MyAngle<=    0) return(1.00000000000000);
   else if (MyAngle<=    5) return(.99619469809175);
   else if (MyAngle<=    10) return(.98480775301221);
   else if (MyAngle<=    15) return(.96592582628907);
   else if (MyAngle<=    20) return(.93969262078591);
   else if (MyAngle<=    25) return(.90630778703665);
   else if (MyAngle<=    30) return(.86602540378444);
   else if (MyAngle<=    35) return(.81915204428899);
   else if (MyAngle<=    40) return(.76604444311898);
   else if (MyAngle<=    45) return(.70710678118655);
   else if (MyAngle<=    50) return(.64278760968654);
   else if (MyAngle<=    55) return(.57357643635105);
   else if (MyAngle<=    60) return(.50000000000000);
   else if (MyAngle<=    65) return(.42261826174070);
   else if (MyAngle<=    70) return(.34202014332567);
   else if (MyAngle<=    75) return(.25881904510252);
   else if (MyAngle<=    80) return(.17364817766693);
   else if (MyAngle<=    85) return(.08715574274766);
   else if (MyAngle<=    90) return(.00000000000000);
   else if (MyAngle<=    95) return(-.08715574274766);
   else if (MyAngle<=    100) return(-.17364817766693);
   else if (MyAngle<=    105) return(-.25881904510252);
   else if (MyAngle<=    110) return(-.34202014332567);
   else if (MyAngle<=    115) return(-.42261826174070);
   else if (MyAngle<=    120) return(-.50000000000000);
   else if (MyAngle<=    125) return(-.57357643635105);
   else if (MyAngle<=    130) return(-.64278760968654);
   else if (MyAngle<=    135) return(-.70710678118655);
   else if (MyAngle<=    140) return(-.76604444311898);
   else if (MyAngle<=    145) return(-.81915204428899);
   else if (MyAngle<=    150) return(-.86602540378444);
   else if (MyAngle<=    155) return(-.90630778703665);
   else if (MyAngle<=    160) return(-.93969262078591);
   else if (MyAngle<=    165) return(-.96592582628907);
   else if (MyAngle<=    170) return(-.98480775301221);
   else if (MyAngle<=    175) return(-.99619469809175);
   else if (MyAngle<=    180) return(-1.00000000000000);
   else if (MyAngle<=    185) return(-.99619469809175);
   else if (MyAngle<=    190) return(-.98480775301221);
   else if (MyAngle<=    195) return(-.96592582628907);
   else if (MyAngle<=    200) return(-.93969262078591);
   else if (MyAngle<=    205) return(-.90630778703665);
   else if (MyAngle<=    210) return(-.86602540378444);
   else if (MyAngle<=    215) return(-.81915204428899);
   else if (MyAngle<=    220) return(-.76604444311898);
   else if (MyAngle<=    225) return(-.70710678118655);
   else if (MyAngle<=    230) return(-.64278760968654);
   else if (MyAngle<=    235) return(-.57357643635105);
   else if (MyAngle<=    240) return(-.50000000000000);
   else if (MyAngle<=    245) return(-.42261826174070);
   else if (MyAngle<=    250) return(-.34202014332567);
   else if (MyAngle<=    255) return(-.25881904510252);
   else if (MyAngle<=    260) return(-.17364817766693);
   else if (MyAngle<=    265) return(-.08715574274766);
   else if (MyAngle<=    270) return(.00000000000000);
   else if (MyAngle<=    275) return(.08715574274766);
   else if (MyAngle<=    280) return(.17364817766693);
   else if (MyAngle<=    285) return(.25881904510252);
   else if (MyAngle<=    290) return(.34202014332567);
   else if (MyAngle<=    295) return(.42261826174070);
   else if (MyAngle<=    300) return(.50000000000000);
   else if (MyAngle<=    305) return(.57357643635105);
   else if (MyAngle<=    310) return(.64278760968654);
   else if (MyAngle<=    315) return(.70710678118655);
   else if (MyAngle<=    320) return(.76604444311898);
   else if (MyAngle<=    325) return(.81915204428899);
   else if (MyAngle<=    330) return(.86602540378444);
   else if (MyAngle<=    335) return(.90630778703665);
   else if (MyAngle<=    340) return(.93969262078591);
   else if (MyAngle<=    345) return(.96592582628907);
   else if (MyAngle<=    350) return(.98480775301221);
   else if (MyAngle<=    355) return(.99619469809175);
   else if (MyAngle<=    360) return(1.00000000000000);
}
float GetXPointOnCircle(float Angle=0, float Radius=0, float AtX=.5) {
   float MyX = (Radius * cos(Angle) + AtX); // FIND X AT CIRCLES EDGE
   MyX = iifF(MyX<0,0,MyX);
   MyX = iifF(MyX>1,1,MyX);
   return (MyX);
}
float GetZPointOnCircle(float Angle=0, float Radius=0, float AtZ=.5) {
   float MyZ = (Radius * sin(Angle) + AtZ); // FIND Z AT CIRCLES EDGE
   MyZ = iifF(MyZ<0,0,MyZ);
   MyZ = iifF(MyZ>1,1,MyZ);
   return (MyZ);
}
int ObjectsInACircle(int id=0, float StartAngle=0, float EndAngle=0, float AngleBetween=0, float Radius=0, float StartX=.5, float StartZ=.5, int PlayerId=0, int Count=0) {
   // RADIUS AS FRACTION, WIDTH IN METERS
   float ThisAngle=iifF(EndAngle<StartAngle,(EndAngle+360)-StartAngle,EndAngle-StartAngle);
   int NumberOfAngles = (ThisAngle)/AngleBetween; // NUMBER OF ANGLES BETWEEN
   ThisAngle = StartAngle;
   for (i=0; <=NumberOfAngles) {
      float MyAtX=GetXPointOnCircle(ThisAngle, Radius, StartX);
      float MyAtZ=GetZPointOnCircle(ThisAngle, Radius, StartZ);
      ThisAngle=ThisAngle+AngleBetween;
      rmPlaceObjectDefAtLoc(id, PlayerId, MyAtX, MyAtZ, Count);
   }
   return(id);
}
/* SKINNING FUNCTIONS  ************************************/
float GetAnimalCount(string Animal="") {
   // RETURNS THE FOOD VALUE FOR FOOD TYPES, OR HIT POINTS FOR PREDATORS
   // USED TO HELP DETERMINE THE NUMBER OF EACH TYPE TO PLACE
   // THESE ARE NUTRITIONAL VALUES
   if (Animal=="Aurochs") return (rmRandInt(2,3)); //(400.0));
   if (Animal=="Baboon") return (rmRandInt(6,12)); //(80.0));
   if (Animal=="Berry Bush") return (rmRandInt(6,12)); //(100.0));
   if (Animal=="Boar") return (rmRandInt(2,5)); //(300.0));
   if (Animal=="Caribou") return (rmRandInt(3,6)); //(150.0));
   if (Animal=="Chicken") return (rmRandInt(7,10)); //(75.0));
   if (Animal=="Cow") return (rmRandInt(2,3)); //(75.0));
   if (Animal=="Crocodile") return (rmRandInt(2,3)); //(200.0));
   if (Animal=="Crowned Crane") return (rmRandInt(5,10)); //(100.0));
   if (Animal=="Deer") return (rmRandInt(4,8)); //(150.0));
   if (Animal=="Elephant") return (rmRandInt(2,3)); //(750.0));
   if (Animal=="Elk") return (rmRandInt(3,5)); //(150.0));
   if (Animal=="Fish - Mahi") return (rmRandInt(2,3)); //(100.0));
   if (Animal=="Fish - Perch") return (rmRandInt(2,3)); //(100.0));
   if (Animal=="Fish - Salmon") return (rmRandInt(2,3)); //(100.0));
   if (Animal=="Gazelle") return (rmRandInt(5,10)); //(100.0));
   if (Animal=="Giraffe") return (rmRandInt(2,4)); //(300.0));
   if (Animal=="Goat") return (rmRandInt(2,3)); //(50.0));
   if (Animal=="Hippo") return (rmRandInt(2,3)); //(400.0));
   if (Animal=="Monkey") return (rmRandInt(6,12)); //(100.0));
   if (Animal=="Pig") return (rmRandInt(2,3)); //(50.0));
   if (Animal=="Rhinocerous") return (rmRandInt(2,3)); //(500.0));
   if (Animal=="Walrus") return (rmRandInt(3,6)); //(100.0));
   if (Animal=="Water Buffalo") return (rmRandInt(2,3)); //(400.0));
   if (Animal=="Zebra") return (rmRandInt(4,7)); //(200.0));
   // THESE ARE HITPOINTS
   if (Animal=="Ape Of Set") return (rmRandInt(2,3)); //(45.0));
   if (Animal=="Bear") return (rmRandInt(2,3)); //(90.0));
   if (Animal=="Hyena") return (rmRandInt(2,3)); //(80.0));
   if (Animal=="Hyena Of Set") return (rmRandInt(2,3)); //(45.0));
   if (Animal=="Lion") return (rmRandInt(2,3)); //(60.0));
   if (Animal=="Polar Bear") return (rmRandInt(2,3)); //(90.0));
   if (Animal=="Rhinocerous Of Set") return (rmRandInt(2,3)); //(180.0));
   if (Animal=="Shade of erebus") return (rmRandInt(2,3)); //(90.0));
   if (Animal=="Serpent") return (rmRandInt(2,3)); //(90.0));
   if (Animal=="Wolf") return (rmRandInt(2,3)); //(45.0));
   rmEchoInfo("Animal not found="+Animal);
   return(1000.0);
}
string GetAnimalType(int HerdHuntFishPred=0) {
   // RANDOMLY SELECT AN ANIMAL BASED ON MapSkin
   int ThisSkin=MapSkin;
   int rand=0;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   if (HerdHuntFishPred==1) { // LOOKING FOR HERDABLE TYPE
      if (ThisSkin==1) {// WINTER HERDABLE
         rand = rmRandInt(1,5);
         if (rand==1) return("Berry Bush");
         else if (rand==2) return("Pig");
         else if (rand==3) return("goat");
         else if (rand==4) return("Cow");
         else if (rand==5) return("Crowned Crane");
      }
      if (ThisSkin==2) {// SPRING HERDABLE
         rand = rmRandInt(1,5);
         if (rand==1) return("Berry Bush");
         else if (rand==2) return("Goat");
         else if (rand==3) return("Pig");
         else if (rand==4) return("Crowned Crane");
         else if (rand==5) return("Chicken");
      }
      if (ThisSkin==3) {// SUMMER HERDABLE
         rand = rmRandInt(1,4);
         if (rand==1) return("Berry Bush");
         else if (rand==2) return("Aurochs");
         else if (rand==3) return("Cow");
         else if (rand==4) return("Cow");
      }
      if (ThisSkin==4) {// FALL HERDABLE
         rand = rmRandInt(1,3);
         if (rand==1) return("Berry Bush");
         else if (rand==2) return("Goat");
         else if (rand==3) return("Pig");
      }
      if (ThisSkin==5) {// MORDOR HERDABLE
         rand = rmRandInt(1,3);
         if (rand==1) return("Berry Bush");
         else if (rand==2) return("Aurochs");
         else if (rand==3) return("Pig");
      }
   } else if (HerdHuntFishPred==2) { // LOOKING FOR HUNTABLE
      if (ThisSkin==1 || ThisSkin==4) {// WINTER/FALL HUNTABLE
         rand = rmRandInt(1,4+WaterOnMap); // A 1 IF SEA TO POSSIBLY PLACE A WATER TYPE ANIMAL
         if (rand==1) return("Caribou");
         else if (rand==2) return("Deer");
         else if (rand==3) return("Deer");
         else if (rand==4) return("Elk");
      }
      if (ThisSkin==2 || ThisSkin==3) {// SPRING/SUMMER HUNTS
         rand = rmRandInt(1,10+WaterOnMap);
         if (rand==1) return("Gazelle");
         else if (rand==2) return("Giraffe");
         else if (rand==3) return("Rhinocerous");
         else if (rand==4) return("Elephant");
         else if (rand==5) return("Hippo");
         else if (rand==6) return("Zebra");
         else if (rand==7) return("Monkey");
         else if (rand==8) return("Baboon");
         else if (rand==9) return("Boar");
         else if (rand==10) return("Aurochs");
      }
      if (ThisSkin==5) {// MORDOR HUNTABLE
         rand = rmRandInt(1,3);
         if (rand==1) return("Baboon");
         else if (rand==2) return("Boar");
         else if (rand==3) return("Rhinocerous");
      }
      rand = rmRandInt(1,2); // IF A SEA MAP, THEN PLACE A WATER TYPE ANIMAL
      if (rand==1) return("Walrus");
      else if (rand==2) return("Water Buffalo");
   } else if (HerdHuntFishPred==3) { // LOOKING FOR FISHABLE
      rand = rmRandInt(1,3);
      if (rand==1) return("Fish - Mahi");
      else if (rand==2) return("Fish - Perch");
      else if (rand==3) return("Fish - Salmon");
   } else if (HerdHuntFishPred==4) { // LOOKING FOR PREDATORS
      if (ThisSkin==1 || ThisSkin==4) {// WINTER/FALL PREDATORS
         rand = rmRandInt(1,3);
         if (rand==1) return("Polar Bear");
         else if (rand==2) return("Wolf");
         else if (rand==3) return("Bear");
      }
      if (ThisSkin==2 || ThisSkin==3) {// SPRING/SUMMER PREDATORS
         rand = rmRandInt(1,6+WaterOnMap);
         if (rand==1) return("Hyena");
         else if (rand==2) return("Lion");
         else if (rand==3) return("Serpent");
         else if (rand==4) return("Bear");
         else if (rand==5) return("Ape Of Set");
         else if (rand==6) return("Wolf");
      }
      if (ThisSkin==5) {// MORDOR PREDATORS
         rand = rmRandInt(1,5);
         if (rand==1) return("Serpent");
         else if (rand==2) return("Shade of erebus");
         else if (rand==3) return("Ape Of Set");
         else if (rand==4) return("Hyena Of Set");
         else if (rand==5) return("Rhinoceros Of Set");
      }
      return("Crocodile"); // IF WATER MAP AND NONE SELECTED
   }
}


int CreateAnimals(string ObjName="", int HerdHuntFishPred=0, int MinDist=0, int MaxDist=0, int AddToClass=0, int Constraint1=0, int Constraint2=0, int Constraint3=0, int Constraint4=0) {
   string Animal = GetAnimalType(HerdHuntFishPred);
   float NumToPlace = GetAnimalCount(Animal);
   NumToPlace = iifF(NumToPlace<2,2,NumToPlace); // ALWAYS PLACE AT LEAST TWO
   rmEchoInfo("Placing "+NumToPlace+" "+Animal);
   int id=rmCreateObjectDef("Animal"+Animal+ObjName);
   rmAddObjectDefItem(id, Animal, NumToPlace, 3.0 * HerdHuntFishPred);
   rmSetObjectDefMinDistance(id, MinDist);
   rmSetObjectDefMaxDistance(id, MaxDist);
   if (AddToClass>0) rmAddObjectDefToClass(id, AddToClass);
   if (Constraint1>0) rmAddObjectDefConstraint(id, Constraint1);
   if (Constraint2>0) rmAddObjectDefConstraint(id, Constraint2);
   if (Constraint3>0) rmAddObjectDefConstraint(id, Constraint3);
   if (Constraint4>0) rmAddObjectDefConstraint(id, Constraint4);
   if (HerdHuntFishPred==2) {
      rmAddObjectDefConstraint(id, avoidAnimalsMedium);
      rmAddObjectDefConstraint(id, avoidBuildingsMedium);
   } else {
      rmAddObjectDefConstraint(id, avoidAnimalsShort);
      rmAddObjectDefConstraint(id, avoidBuildingsShort);
   }
   if (Animal=="Walrus" || Animal=="Water Buffalo" || Animal=="Crocodile") {
      rmAddObjectDefConstraint(id, nearShoreLineVeryShort);
   } else if (HerdHuntFishPred!=3) { // NOT FISH, AVOID WATERS EDGE
      rmAddObjectDefConstraint(id, avoidWaterVeryShort);
   }
   return(id);
}

void PlaceGold(int Amount=0, int MinDist=0, int MaxDist=0, int idTiny=0, int idSmall=0, int idLarge=0) {
   rmSetObjectDefMinDistance(idTiny,MinDist);
   rmSetObjectDefMaxDistance(idTiny,MaxDist);
   rmSetObjectDefMinDistance(idSmall,MinDist);
   rmSetObjectDefMaxDistance(idSmall,MaxDist);
   rmSetObjectDefMinDistance(idLarge,MinDist);
   rmSetObjectDefMaxDistance(idLarge,MaxDist);
   int RemainAmount = Amount;
   int j=0;
   for (i=1; <cNumberPlayers*2) { // ONLY LOOP SO MANY TIMES REGARDLESS OF REQUEST AMOUNT
      if (RemainAmount < cGoldAmtTiny/2) break; // NOT AT LEAST 1/2 A TINY TO PLACE, SO EXIT LOOP
      if (RemainAmount>=cGoldAmtLarge) j = rmRandInt(2,3); // RANDOMLY PICK ANY SIZE
      else if (RemainAmount>=cGoldAmtSmall) j = rmRandInt(1,2); // RANDOMLY PICK SMALLER SIZE
      else j = 1; // IT"S TINY
      if (j == 1) {
         RemainAmount = RemainAmount - cGoldAmtTiny;
         rmPlaceObjectDefPerPlayer(idTiny,false,1);
      } else if (j == 2) {
         RemainAmount = RemainAmount - cGoldAmtSmall;
         rmPlaceObjectDefPerPlayer(idSmall,false,1);
      } else if (j == 3) {
         RemainAmount = RemainAmount - cGoldAmtLarge;
         rmPlaceObjectDefPerPlayer(idLarge,false,1);
      }
   }
}

void GoldConstr(int id=0, int Constraint1=0, int Constraint2=0, int Constraint3=0, int Constraint4=0) {
   rmAddObjectDefConstraint(id, avoidGoldLong);
   rmAddObjectDefConstraint(id, avoidMapEdgesShort);
   rmAddObjectDefConstraint(id, avoidBuildingsShort);
   rmAddObjectDefConstraint(id, avoidWaterVeryShort);
//   rmAddObjectDefConstraint(id, avoidAllShort);
   if (Constraint1>0) rmAddObjectDefConstraint(id, Constraint1);
   if (Constraint2>0) rmAddObjectDefConstraint(id, Constraint2);
   if (Constraint3>0) rmAddObjectDefConstraint(id, Constraint3);
   if (Constraint4>0) rmAddObjectDefConstraint(id, Constraint4);
}

void CreateGold(int CloseAmount=0, float CloseDist=0, int NearByAmount=0, float NearByDist=0, int FarAmount=0, float FarDist=0, int Constraint1=0, int Constraint2=0, int Constraint3=0, int Constraint4=0) {
   int idTiny = rmCreateObjectDef("GoldTiny");
   rmAddObjectDefItem(idTiny,"Gold Mine Tiny",1,0.0);
   GoldConstr(idTiny, Constraint1, Constraint2, Constraint3, Constraint4);

   int idSmall = rmCreateObjectDef("GoldSmall");
   rmAddObjectDefItem(idSmall,"Gold Mine Small",1,0.0);
   GoldConstr(idSmall, Constraint1, Constraint2, Constraint3, Constraint4);

   int idLarge = rmCreateObjectDef("GoldLarge");
   rmAddObjectDefItem(idLarge,"Gold Mine",1,0.0);
   GoldConstr(idLarge, Constraint1, Constraint2, Constraint3, Constraint4);

   PlaceGold(CloseAmount, 6, CloseDist, idTiny, idSmall, idLarge);
   PlaceGold(NearByAmount, CloseDist, NearByDist, idTiny, idSmall, idLarge);
   PlaceGold(FarAmount, NearByDist, FarDist, idTiny, idSmall, idLarge);
}

string GetBirdType() {
   int ThisSkin=MapSkin;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   if (rmRandInt(1,10)==1 && MapSkin==5) return("Flying Purple Hippo"); // Whee! - Only MORDER
   if (rmRandInt(1,10)==1) return("Harpy"); // Controlable
   else if (ThisSkin==1) return("Vulture"); // WINTER
   else if (ThisSkin==2) return("Hawk"); // SPRING
   else if (ThisSkin==3) return("Hawk"); // SUMMER
   else if (ThisSkin==4) return("Vulture"); // FALL
   else if (ThisSkin==5) return("Harpy"); // MORDER
}

string GetSeaType() {
   int ThisSkin=MapSkin;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   if (ThisSkin==1) return("North Atlantic Ocean"); // WINTER
   else if (ThisSkin==2) return("Red Sea"); // SPRING
   else if (ThisSkin==3) return("Aegean Sea"); // SPRING
   else if (ThisSkin==4) return("Norwegian Sea");// FALL
   else if (ThisSkin==5) return("Styx River"); // MORDOR
}

string GetLakeType() {
   int ThisSkin=MapSkin;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   if (ThisSkin==1) return("Norse River"); // WINTER
   else if (ThisSkin==2) return("Savannah Water Hole"); // SPRING
   else if (ThisSkin==3) return("Greek River"); // SUMMER
   else if (ThisSkin==4) return("Norse River");// FALL
   else if (ThisSkin==5) return("Styx River"); // MORDOR
}

string GetLandType() {
   int ThisSkin=MapSkin;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   if (ThisSkin==1) return("CliffNorseB"); // WINTER
   else if (ThisSkin==2) return("SavannahA"); // SPRING
   else if (ThisSkin==3) return("GrassA"); // SUMMER
   else if (ThisSkin==4) return("SnowGrass75"); // FALL
   else if (ThisSkin==5) return("ForestFloorDeadPine"); // MORDOR
}

string GetTreeType(int ForestOrTreeType=0) {
   int ThisSkin=MapSkin;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   if (ForestOrTreeType==1) { // LOOKING FOR A FOREST TYPE
      if (ThisSkin==1) { // WINTER
         ThisSkin=rmRandInt(1,2);
         if (ThisSkin==1) return("Snow Pine Forest");
         else if (ThisSkin==2) return("Mixed Pine Forest");
      }
      else if (ThisSkin==2) return("Savannah Forest"); // SPRING
      else if (ThisSkin==3) { // SUMMER
         ThisSkin=rmRandInt(1,4);
         if (ThisSkin==1) return("Mixed Oak Forest");
         else if (ThisSkin==2) return("Pine Forest");
         else if (ThisSkin==3) return("Oak Forest");
         else if (ThisSkin==4) return("Palm Forest");
      }
      else if (ThisSkin==4) { // FALL
         ThisSkin=rmRandInt(1,2);
         if (ThisSkin==1) return("Autumn Oak Forest");
         else if (ThisSkin==2) return("Pine Forest");
      }
      else if (ThisSkin==5) return("Hades Forest"); // MORDOR
   } else { // INDIVIDUAL TREE
      if (ThisSkin==1) return("Pine Snow"); // WINTER
      else if (ThisSkin==2) return("Savannah Tree"); // SPRING
      else if (ThisSkin==3) {
         ThisSkin=rmRandInt(1,3);
         if (ThisSkin==1) return("Oak Tree");
         else if (ThisSkin==2) return("Pine");
         else if (ThisSkin==3) return("Palm");
      }
      else if (ThisSkin==4) {
         ThisSkin=rmRandInt(1,2); // FALL
         if (ThisSkin==1) return("Oak Autumn");
         else if (ThisSkin==2) return("Pine");
      }
      else if (ThisSkin==5) return("Pine Dead"); // MORDOR
   }
}

string GetCliffType() {
   int ThisSkin=MapSkin;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   if (ThisSkin==1) return("Norse"); // WINTER
   else if (ThisSkin==2) return("Egyptian"); // SPRING
   else if (ThisSkin==3) return("Greek"); // SUMMER
   else if (ThisSkin==4) return("Norse"); // FALL
   else if (ThisSkin==5) return("Hades"); // MORDOR
}

string GetRockType(string Size="") {
   int ThisSkin=MapSkin;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   if (ThisSkin==1) {
      if (rmRandInt(1,10)>1) return("Rock Granite "+Size); // WINTER
      else return ("Rock River Icy");
   }
   else if (ThisSkin==2 || ThisSkin==3) return("Rock Sandstone "+Size); // SPRING/SUMMER
   else if (ThisSkin==4) return("Rock Limestone "+Size); // FALL
   else if (ThisSkin==5) return("Stalagmite"); // MORDOR
   /* Look into these: Rock Cliff, Rock River Grassy, Rock River Icy, Rock River Sandy, Rock Snow, Rock Symbols */
}

string GetRoadType() {
   int ThisSkin=MapSkin;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   if (ThisSkin==1) return("NorseRoadA"); // WINTER
   else if (ThisSkin==2) return("GreekRoadA"); // SPRING
   else if (ThisSkin==3) { // SUMMER
      if (rmRandInt(2,2)==1) return("CityTileA");
      return("CityTileAtlantis");
   }
   else if (ThisSkin==4) return("NorseRoadA"); // FALL
   else if (ThisSkin==5) return("UnderWaterRockC"); // MORDOR
}

string GetWaterPlant(int Lake=0) {
   if (rmRandInt(1,50)==1) return ("Sea Snake"); // ssss
   if (rmRandInt(1,200)==1) return("monkey raft");// HAVE SOME FUN WILL YA?
   if (rmRandInt(1,300)==1) return("Sea Turtle");// WICKED
   if (rmRandInt(1,300)==1) return("Jormund Elver");// OLLIE
   int WhichPlant=rmRandInt(1,6);
   if (Lake==1) WhichPlant=rmRandInt(1,5);
   if (WhichPlant==1) return("water lilly");
   else if (WhichPlant==2) return("papyrus");
   else if (WhichPlant==3) return("Water decoration");
   else if (WhichPlant==4) return("Water Reeds");
   else if (WhichPlant==5) return("Hawksbill"); // I Know
   else if (WhichPlant==6) return("Seaweed");
}

string GetBigFish() {
   int ThisSkin= rmRandInt(1,3);
   if (ThisSkin==1) return("Orca");
   else if (ThisSkin==2) return("Whale");
   else if (ThisSkin==3) return("Shark");
}

void ReplaceWaterWithLand(int id=0) {
   int ThisSkin=MapSkin;
   if (ThisSkin==1) rmAddConnectionTerrainReplacement(id, "ShorelineAtlanticA", "ShorelineAtlanticC"); // WINTER
   else if (ThisSkin==2) rmAddConnectionTerrainReplacement(id, "ShorelineRedSeaA", "ShorelineRedSeaC");//return("Red Sea"); // SPRING
   else if (ThisSkin==3) rmAddConnectionTerrainReplacement(id, "ShorelineAegeanA", "ShorelineAegeanC");//return("Aegean Sea"); // SPRING
   else if (ThisSkin==4) rmAddConnectionTerrainReplacement(id, "ShorelineNorwegianA", "ShorelineNorwegianC");//return("Norwegian Sea");// FALL
//   else if (ThisSkin==5) rmAddConnectionTerrainReplacement(id, "ShorelineAtlanticA", "SavannahC");//return("Styx River"); // MORDOR
}

void LayerTerrain(int id=0, float Width=6) {
   // WIDTH IN METERS!! - Layers starting at 0 go from outer edge toward area center
   int ThisSkin=MapSkin;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   if (ThisSkin==1) { // WINTER
      rmAddAreaTerrainLayer(id,"SnowA",0, Width * .33);
      rmAddAreaTerrainLayer(id,"SnowGrass50",Width * .33,Width * .66);
      rmAddAreaTerrainLayer(id,"SnowGrass25",Width * .66,Width);
   } else if (ThisSkin==2) { // SPRING
      rmAddAreaTerrainLayer(id,"SavannahC",0, Width * .25);
      rmAddAreaTerrainLayer(id,"SavannahD", Width * .25,Width * .5);
      rmAddAreaTerrainLayer(id,"SavannahC", Width * .5,Width * .75);
      rmAddAreaTerrainLayer(id,"SavannahB", Width * .75,Width);
   } else if (ThisSkin==3) { // SUMMER
      rmAddAreaTerrainLayer(id,"GrassDirt25",0, Width * .25);
      rmAddAreaTerrainLayer(id,"CliffGreekB", Width * .25,Width * .5);
      rmAddAreaTerrainLayer(id,"GrassDirt50", Width * .5,Width * .75);
      rmAddAreaTerrainLayer(id,"GrassDirt25", Width * .75,Width);
   } else if (ThisSkin==4) { // FALL
      rmAddAreaTerrainLayer(id,"SnowGrass75",0, Width * .25);
      rmAddAreaTerrainLayer(id,"CliffNorseB", Width * .25,Width * .5);
      rmAddAreaTerrainLayer(id,"SnowGrass50", Width * .5,Width * .75);
      rmAddAreaTerrainLayer(id,"CliffNorseB", Width * .75,Width);
   } else if (ThisSkin==5) { // MORDOR
      rmAddAreaTerrainLayer(id,"UnderWaterRockA",0,Width * .5);
      rmAddAreaTerrainLayer(id,"HadesBuildable2",Width * .5,Width);
   }
}

void LayerVolcanic(int id=0, float Width=6) {
   float LayerWidth = 2;
   int Bright=rmRandInt(1,2);
   Bright=1;
   rmAddAreaTerrainLayer(id,"Hades1",Width*0,Width*.25);
   int ThisSkin=MapSkin;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   if (ThisSkin==1) { // WINTER
      rmAddAreaTerrainLayer(id,"CliffNorseA",Width*0,Width*.5);
   } else if (ThisSkin==2) { // SPRING
      rmAddAreaTerrainLayer(id,"CliffEgyptianA",Width*0,Width*.5);
   } else if (ThisSkin==3) { // SUMMER
      rmAddAreaTerrainLayer(id,"RiverGrassyA",Width*0,Width*.5);
   } else if (ThisSkin==4) { // FALL
      rmAddAreaTerrainLayer(id,"CliffNorseA",Width*0,Width*.5);
   } else if (ThisSkin==5) { // MORDOR
      rmAddAreaTerrainLayer(id,"UnderWaterRockA",Width*0,Width*.5);
   }
   rmAddAreaTerrainLayer(id,"HadesCliff",Width*.5,Width*.75);
   rmAddAreaTerrainLayer(id,"Hades3",Width*.75,Width);
}

void LayerForest(int id=0, float Width=6) {
   int ThisSkin=MapSkin;
   if (ThisSkin==0) ThisSkin = rmRandInt(1,5); // RANDOM TYPE
   rmSetAreaTerrainType(id,"ForestFloorDeadPine");
   if (ThisSkin==1) { // WINTER
      rmAddAreaTerrainLayer(id,"ShoreLineNorwegianC",Width*0,Width*.25);
   } else if (ThisSkin==2) { // SPRING
      rmAddAreaTerrainLayer(id,"MiningGround",Width*0,Width*.25);
   } else if (ThisSkin==3) { // SUMMER
      rmAddAreaTerrainLayer(id,"ForestFloorPine",Width*0,Width*.25);
   } else if (ThisSkin==4) { // FALL
      rmAddAreaTerrainLayer(id,"ForestFloorPine",Width*0,Width*.25);
   } else if (ThisSkin==5) { // MORDOR
      rmAddAreaTerrainLayer(id,"UnderWaterRockA",Width*0,Width*.25);
   }
   rmAddAreaTerrainLayer(id,"ForestFloorDeadPine",Width*.25,Width*.5);
   rmAddAreaTerrainLayer(id,"HadesBuildable1",Width*.5,Width*.75);
   rmAddAreaTerrainLayer(id,"HadesBuildable2",Width*.75,Width);
}


void SetMainLandType(int id=0, int LayerWidth=0, int Height=2, string ForceType="") {
   if (ForceType=="") {
      rmSetAreaTerrainType(id,GetLandType());
      LayerTerrain(id, LayerWidth);
   } else {
      rmSetAreaTerrainType(id,ForceType);
   }
   rmSetAreaSmoothDistance(id,6);
   rmSetAreaBaseHeight(id,Height);
}

void SetMainWaterType(int id=0) {
   rmSetAreaWaterType(id, GetSeaType());
}

void AddRocks(int Num=0, int Constraint1=0, int Constraint2=0, int Constraint3=0, int Constraint4=0) {
   string type="sprite";
   for (i=1; <=3) {
      if (i==2) type="small";
      else if (i==3) type="big";
      if (Num>0) {
         int id=rmCreateObjectDef("rock "+type);
         rmAddObjectDefItem(id, GetRockType(type), 1, 0.0);
         rmSetObjectDefMinDistance(id, 0.0);
         rmSetObjectDefMaxDistance(id, rmXFractionToMeters(0.5));
         if (Constraint1>0) rmAddObjectDefConstraint(id, Constraint1);
         if (Constraint2>0) rmAddObjectDefConstraint(id, Constraint2);
         if (Constraint3>0) rmAddObjectDefConstraint(id, Constraint3);
         if (Constraint4>0) rmAddObjectDefConstraint(id, Constraint4);
         rmPlaceObjectDefAtLoc(id, 0, 0.5, 0.5, Num);
      }
   }
}


/* AREA FUNCTIONS  ************************************/
int CreateAreaAtXZ(string ObjName="", float AtX=.5, float AtZ=.5, float WidthX=0, float WidthZ=0, float HeightBlend=2, float Coherence=1, int ParentArea=0) {
   int id = 0;
   if (ParentArea>0) id = rmCreateArea(ObjName, ParentArea);
   else id = rmCreateArea(ObjName);
   rmSetAreaHeightBlend(id,HeightBlend);
   if (AtX>-1 && AtZ>-1) rmSetAreaLocation(id,AtX,AtZ);
   rmSetAreaSize(id,WidthX,WidthZ);
   rmSetAreaCoherence(id,Coherence);
   return (id);
}

void BlobulateArea(int id=0, int MinBlobs=0, int MinBlobDist=0,  int MaxBlobs=0, int MaxBlobDist=0) {
   rmSetAreaMinBlobs(id,MinBlobs);
   rmSetAreaMaxBlobs(id,MaxBlobs);
   rmSetAreaMinBlobDistance(id, MinBlobDist);
   rmSetAreaMaxBlobDistance(id, MaxBlobDist);
}

void LandArea(string ObjName="", int numAreas=0, float MinHeight=0.0, float MaxHeight=0.0, float WidthX=0, float WidthZ=0, int AddToClass=0, int ParentArea=0, int Constraint1=0, int Constraint2=0, int Constraint3=0, int Constraint4=0) {
   float ThisHeight=0;
   for(i=0; <numAreas) {
      int id = CreateAreaAtXZ(ObjName+i, -1, -1, rmZMetersToFraction(WidthX), rmZMetersToFraction(WidthZ), 3, 0, ParentArea);
      rmSetAreaWarnFailure(id, false);
      ThisHeight=rmRandFloat(MinHeight, MaxHeight);
      rmSetAreaSmoothDistance(id, 10);
      BlobulateArea(id, 1, rmRandInt(10, 16),  rmRandInt(3, 10), rmRandInt(16, 25));
      if (AddToClass>0) rmAddAreaToClass(id, AddToClass);
      if (Constraint1>0) rmAddAreaConstraint(id, Constraint1);
      if (Constraint2>0) rmAddAreaConstraint(id, Constraint2);
      if (Constraint3>0) rmAddAreaConstraint(id, Constraint3);
      if (Constraint4>0) rmAddAreaConstraint(id, Constraint4);
      SetMainLandType(id, 6, ThisHeight);
      if(rmBuildArea(id)==false) { // Stop trying once we fail 3 times in a row.
         failCount++;
         if (failCount==3) break;
      } else failCount=0;
   }
}

void CliffArea(string ObjName="", int numAreas=0, float MinHeight=0.0, float MaxHeight=0.0, float WidthX=0, float WidthZ=0, int AddToClass=0, int Constraint1=0, int Constraint2=0, int Constraint3=0, int Constraint4=0) {
   failCount=0;
   float NumEdges=rmRandFloat(1,4);
   for(i=1; <=numAreas) {
      int id = CreateAreaAtXZ(ObjName+i, -1, -1, rmXMetersToFraction(WidthX), rmZMetersToFraction(WidthZ), 1, 0);
      rmSetAreaWarnFailure(id, false);
      BlobulateArea(id, 3, rmRandInt(3, 5),  rmRandInt(10, 15), rmRandInt(15, 40));
      rmSetAreaSmoothDistance(id, 10);
      if (AddToClass>0) rmAddAreaToClass(id, AddToClass);
      if (Constraint1>0) rmAddAreaConstraint(id, Constraint1);
      if (Constraint2>0) rmAddAreaConstraint(id, Constraint2);
      if (Constraint3>0) rmAddAreaConstraint(id, Constraint3);
      if (Constraint4>0) rmAddAreaConstraint(id, Constraint4);
      rmSetAreaCliffType(id, GetCliffType());
      rmSetAreaCliffEdge(id, NumEdges, 1.0/NumEdges, 0.1, 1.0, 0);
      rmSetAreaCliffPainting(id, true, true, true, 1.5, true);
      rmSetAreaCliffHeight(id, rmRandInt(MinHeight,MaxHeight), 1.0, 1.0);
      LayerTerrain(id, 6);
      if(rmBuildArea(id)==false) { // Stop trying once we fail 3 times in a row.
         failCount++;
         if (failCount==3) break;
      } else failCount=0;
   }
}

void RandomTrees() {
   rmSetObjectDefMinDistance(idTree1, 35);
   rmSetObjectDefMaxDistance(idTree1, rmZFractionToMeters(.5));
   rmSetObjectDefMinDistance(idTree2, 35);
   rmSetObjectDefMaxDistance(idTree2, rmZFractionToMeters(.5));
   rmSetObjectDefMinDistance(idTree3, 35);
   rmSetObjectDefMaxDistance(idTree3, rmZFractionToMeters(.5));
   rmSetObjectDefMinDistance(idTree4, 35);
   rmSetObjectDefMaxDistance(idTree4, rmZFractionToMeters(.5));
   rmPlaceObjectDefPerPlayer(idTree1, false, 5);
   rmPlaceObjectDefPerPlayer(idTree2, false, 5);
   rmPlaceObjectDefPerPlayer(idTree3, false, 5);
   rmPlaceObjectDefPerPlayer(idTree4, false, 5);

   rmSetObjectDefMinDistance(idTree1, iifF(MapSkin==5,40.0,10.0));// NO BURNING TREES ON
   rmSetObjectDefMaxDistance(idTree1, iifF(MapSkin==5,70.0,35.0));// OUR LAWN PLEASE
   rmSetObjectDefMinDistance(idTree2, iifF(MapSkin==5,40.0,10.0));// NO BURNING TREES ON
   rmSetObjectDefMaxDistance(idTree2, iifF(MapSkin==5,70.0,35.0));// OUR LAWN PLEASE
   rmSetObjectDefMinDistance(idTree3, iifF(MapSkin==5,40.0,10.0));// NO BURNING TREES ON
   rmSetObjectDefMaxDistance(idTree3, iifF(MapSkin==5,70.0,35.0));// OUR LAWN PLEASE
   rmSetObjectDefMinDistance(idTree4, iifF(MapSkin==5,40.0,10.0));// NO BURNING TREES ON
   rmSetObjectDefMaxDistance(idTree4, iifF(MapSkin==5,70.0,35.0));// OUR LAWN PLEASE
   rmPlaceObjectDefPerPlayer(idTree1, false, 7); // FOR THE PLAYER AREAS
   rmPlaceObjectDefPerPlayer(idTree2, false, 7); // FOR THE PLAYER AREAS
   rmPlaceObjectDefPerPlayer(idTree3, false, 7); // FOR THE PLAYER AREAS
   rmPlaceObjectDefPerPlayer(idTree4, false, 7); // FOR THE PLAYER AREAS
}

void ForestArea(string ObjName="", int numAreas=0, float WidthX=0, float WidthZ=0, int AddToClass=0, int Constraint1=0, int Constraint2=0, int Constraint3=0, int Constraint4=0, int ParentArea=0) {
   failCount=0;
   float ThisHeight=0;
   float NumCliffs=rmRandFloat(1,3);
   for(i=1; <=numAreas) {
      int id = CreateAreaAtXZ(ObjName+"Forest"+i, -1, -1, rmZMetersToFraction(WidthX), rmZMetersToFraction(WidthZ), 2, 0, ParentArea);
      if (AddToClass>0) rmAddAreaToClass(id, AddToClass); // ONLY ADD INPASSABLE FOREST TO CLASS
      rmSetAreaWarnFailure(id, false);
      LayerForest(id, 6);
      BlobulateArea(id, 1, rmRandInt(10, 16),  rmRandInt(3, 10), rmRandInt(16, 25));
      if (Constraint1>0) rmAddAreaConstraint(id, Constraint1);
      if (Constraint2>0) rmAddAreaConstraint(id, Constraint2);
      if (Constraint3>0) rmAddAreaConstraint(id, Constraint3);
      if (Constraint4>0) rmAddAreaConstraint(id, Constraint4);
      if(rmBuildArea(id)==false) { // Stop trying once we fail 3 times in a row.
         failCount++;
         if (failCount==3) break;
      } else failCount=0;
      int fid = CreateAreaAtXZ(ObjName+"ImpassForest"+i, -1, -1, rmZMetersToFraction(WidthX/5), rmZMetersToFraction(WidthZ/5), 2, 0, id);
      rmSetAreaWarnFailure(fid, false);
      rmSetAreaForestType(fid,GetTreeType(1));
      if(rmBuildArea(fid)==false) { // Stop trying once we fail X times in a row.
         failCount++;
         if (failCount==5) break;
      } else failCount=0;
      rmPlaceObjectDefInArea(idTree1,0,id,WidthX * WidthZ/2);
      rmPlaceObjectDefInArea(idTree2,0,id,WidthX * WidthZ/2);
      rmPlaceObjectDefInArea(idTree3,0,id,WidthX * WidthZ/2);
      rmPlaceObjectDefInArea(idTree4,0,id,WidthX * WidthZ/2);
   }
}

void BeautifyWater(string ObjName="", int id=0, int AddFish=0,  int Embellish=0, int Class=0, int Lake=0) {
   int NumToPlace = rmRandInt(AddFish,AddFish*1.2); // USE A 20% VARIANCE ON THE NUMBER PLACE; REQUEST FOR 10 TO GET 10-12
   if (NumToPlace>0) { // ADD SOME FISH TO THE WATER
      int fishid = rmCreateObjectDef(ObjName+"fish");
      rmAddObjectDefItem(fishid,GetAnimalType(3),1,0.0);
      if (Class==0) rmPlaceObjectDefInArea(fishid, 0, id, NumToPlace);
      else rmPlaceObjectDefInRandomAreaOfClass(fishid, 0, id, NumToPlace);
   }
   NumToPlace = rmRandInt(Embellish,Embellish*1.2); // USE A 20% VARIANCE ON THE NUMBER PLACE; REQUEST FOR 10 TO GET 10-12
   if (NumToPlace>0) { // ADD SOME PLANT LIFE TO THE WATER
      int plantid = rmCreateObjectDef(ObjName+"plant");
      rmAddObjectDefItem(plantid,GetWaterPlant(Lake),3,1.0); // 3 per
      if (Class==0) rmPlaceObjectDefInArea(plantid, 0, id, NumToPlace);
      else rmPlaceObjectDefInRandomAreaOfClass(plantid, 0, id, NumToPlace);
   }
}

void WaterArea(string ObjName="", int numAreas=0, float WidthX=0, float WidthZ=0, int AddFish=0, int Embellish=0, int AddToClass=0, int Constraint1=0, int Constraint2=0, int Constraint3=0) {
   failCount=0;
   float ThisHeight=0;
   float NumCliffs=rmRandFloat(1,3);
   for(i=1; <=numAreas) {
      int id = CreateAreaAtXZ(ObjName+"water"+i, -1, -1, rmZMetersToFraction(WidthX), rmZMetersToFraction(WidthZ), 2, 0);
      rmSetAreaWarnFailure(id, false);
      rmSetAreaWaterType(id, GetLakeType());
      BlobulateArea(id, 3, rmRandInt(5, 10),  rmRandInt(10, 20), rmRandInt(10, 25));
      rmSetAreaBaseHeight(id,-4);
      if (AddToClass>0) rmAddAreaToClass(id, AddToClass);
      if (Constraint1>0) rmAddAreaConstraint(id, Constraint1);
      if (Constraint2>0) rmAddAreaConstraint(id, Constraint2);
      if (Constraint3>0) rmAddAreaConstraint(id, Constraint3);
      if (SeaOrLand==1) rmAddAreaConstraint(id, avoidWaterShort);
      if(rmBuildArea(id)==false) { // Stop trying once we fail 3 times in a row.
         failCount++;
         if (failCount==3) break;
      } else {
         failCount=0;
         for(j=1; <=AddFish) BeautifyWater(ObjName+"fish"+i+"_"+j, id, 1, 0, 0, 1);
         for(j=1; <=Embellish) BeautifyWater(ObjName+"plants"+i+"_"+j, id, 0, 1, 0, 1);
      }
   }
}

float Clamp(float val=0) {
   if (val<0)       return(0.0);
   else if (val>1)  return(1.0);
   else             return (val);
}

void MakeVolcano(string ObjName="", int Height=15, int Size=300, float SizeVariance=.15, int HoleDepth=4, int Bright=1, int Embellish=1, float AtX=.5, float AtZ=.5, int classVolcano=0) {
   float VolcanoFraction=rmAreaTilesToFraction(Size);
   float HoleVariance=.15;
   int MinBlobs=1;
   int MinBlobDist=rmZFractionToMeters(VolcanoFraction/2); // DEFAULTS
   int MaxBlobDist=rmZFractionToMeters(VolcanoFraction/2)+5; // DEFAULTS
   float MyAtX = AtX;
   float MyAtZ = AtZ;
   int MyBright = Bright;
   if (AtX==0) MyAtX=rmRandFloat(0, 1); // Random Location
   if (MyAtX+rmXTilesToFraction(cMedium)>1) MyAtX = MyAtX-rmXTilesToFraction(cMedium); // IF PAST EDGE, MOVE IN
   if (MyAtX-rmXTilesToFraction(cMedium)<0) MyAtX = MyAtX+rmXTilesToFraction(cMedium); // IF PAST EDGE, MOVE IN
   if (AtZ==0) MyAtZ=rmRandFloat(0, 1); // Random Location
   if (MyAtZ+rmXTilesToFraction(cMedium)>1) MyAtZ = MyAtZ-rmZTilesToFraction(cMedium); // IF PAST EDGE, MOVE IN
   if (MyAtZ-rmXTilesToFraction(cMedium)<0) MyAtZ = MyAtZ+rmZTilesToFraction(cMedium); // IF PAST EDGE, MOVE IN

   float AwayFromPlayers=rmXMetersToFraction(80 * OnIsland);
   float PLX=0;
   float PLZ=0;
   for(i = 1; <cNumberPlayers) {// IF IN PLAYER AREA MOVE IN
      PLX=rmPlayerLocXFraction(i);
      PLZ=rmPlayerLocZFraction(i);
      if (MyAtX>PLX-AwayFromPlayers && MyAtX<PLX+AwayFromPlayers && MyAtZ>PLZ-AwayFromPlayers && MyAtZ<PLZ+AwayFromPlayers) {
         if (PLX>.5) MyAtX = PLX-AwayFromPlayers;
         else MyAtX = PLX+AwayFromPlayers;
         if (PLZ>.5) MyAtZ = PLZ-AwayFromPlayers;
         else MyAtZ = PLZ+AwayFromPlayers;
      }
   }
   if (Bright>1 || Bright<0) MyBright=1; // BRIGHT = 1 MEANS LAVA STARTS OUT BRIGTHER IN THE CENTER, MORE FLOWING
   int id = CreateAreaAtXZ(ObjName+"Base", MyAtX, MyAtZ, VolcanoFraction * 1.75, VolcanoFraction* 1.75, 2, 1);
   rmSetAreaBaseHeight(id,Height/3);
   rmSetAreaWarnFailure(id, false);
//   rmAddAreaConstraint(id,avoidMapEdgesShort);
//   rmAddAreaConstraint(id,avoidPlayerAreasShort);
   rmSetAreaTerrainType(id,"Hades"+(3+MyBright));
   rmSetAreaSmoothDistance(id, 10);
   BlobulateArea(id, 2, MinBlobDist, 5, MaxBlobDist);
   LayerVolcanic(id,6);
   int myVolcanoBase = id;
   rmAddAreaToClass(id,classVolcano);
   rmBuildArea(id);
   thiserupt=thiserupt+1;
   float jj = rmZFractionToMeters(MyAtX);
   float kk = rmZFractionToMeters(MyAtZ);
   seteruptloc(thiserupt, jj+",0,"+kk);

   float HoleFraction = VolcanoFraction/25;

   int LavaDistMin=15;
   int LavaDistMax=25;
   int LavaDist = rmRandInt(LavaDistMin,LavaDistMax);
   int LavaDist1 = rmRandInt(LavaDistMin,LavaDistMax);
   id = CreateAreaAtXZ(ObjName+"LavaFlow1", Clamp(MyAtX-rmZMetersToFraction(LavaDist)),Clamp(MyAtZ-rmZMetersToFraction(LavaDist1)), HoleFraction*3,HoleFraction*3, 2, 1);
   rmAddAreaConstraint(id, avoidMapEdgesMedium);
   rmSetAreaWarnFailure(id, false);
   BlobulateArea(id, 2, MinBlobDist, 5, MaxBlobDist);
   rmSetAreaBaseHeight(id,Height/rmRandInt(1,2));
   rmAddAreaInfluencePoint(id, MyAtX, MyAtZ);
   rmSetAreaTerrainType(id,"Hades"+(2+rmRandInt(1,3)));
   LayerVolcanic(id,8);
   rmAddAreaToClass(id,classVolcano);
   int myLavaFlow1 = id;

   LavaDist = rmRandInt(LavaDistMin,LavaDistMax);
   LavaDist1 = rmRandInt(LavaDistMin,LavaDistMax);
   id = CreateAreaAtXZ(ObjName+"LavaFlow2", Clamp(MyAtX+rmZMetersToFraction(LavaDist)),Clamp(MyAtZ+rmZMetersToFraction(LavaDist1)), HoleFraction*3,HoleFraction*3, 2, 1);
   rmSetAreaWarnFailure(id, false);
   rmAddAreaConstraint(id, avoidMapEdgesMedium);
   BlobulateArea(id, 2, MinBlobDist, 5, MaxBlobDist);
   rmSetAreaBaseHeight(id,Height/rmRandInt(1,2));
   rmAddAreaInfluencePoint(id, MyAtX, MyAtZ);
   rmSetAreaTerrainType(id,"Hades"+(1+rmRandInt(1,4)));
   LayerVolcanic(id,6);
   rmAddAreaToClass(id,classVolcano);
   int myLavaFlow2 = id;

   LavaDist = rmRandInt(LavaDistMin,LavaDistMax);
   LavaDist1 = rmRandInt(LavaDistMin,LavaDistMax);
   id = CreateAreaAtXZ(ObjName+"LavaFlow3", Clamp(MyAtX+rmZMetersToFraction(LavaDist)),Clamp(MyAtZ-rmZMetersToFraction(LavaDist1)), HoleFraction*3,HoleFraction*3, 2, 1);
   rmSetAreaWarnFailure(id, false);
   rmAddAreaConstraint(id, avoidMapEdgesMedium);
   BlobulateArea(id, 2, MinBlobDist, 5, MaxBlobDist);
   rmSetAreaBaseHeight(id,Height/rmRandInt(1,2));
   rmAddAreaInfluencePoint(id, MyAtX, MyAtZ);
   rmSetAreaTerrainType(id,"Hades"+(1+rmRandInt(1,4)));
   LayerVolcanic(id,6);
   rmAddAreaToClass(id,classVolcano);
   int myLavaFlow3 = id;

   LavaDist = rmRandInt(LavaDistMin,LavaDistMax);
   LavaDist1 = rmRandInt(LavaDistMin,LavaDistMax);
   id = CreateAreaAtXZ(ObjName+"LavaFlow4", Clamp(MyAtX-rmZMetersToFraction(LavaDist)),Clamp(MyAtZ+rmZMetersToFraction(LavaDist1)), HoleFraction*3,HoleFraction*3, 2, 1);
   rmSetAreaWarnFailure(id, false);
   rmAddAreaConstraint(id, avoidMapEdgesMedium);
   BlobulateArea(id, 2, MinBlobDist, 5, MaxBlobDist);
   rmSetAreaBaseHeight(id,Height/rmRandInt(1,2));
   rmAddAreaInfluencePoint(id, MyAtX, MyAtZ);
   rmSetAreaTerrainType(id,"Hades"+(1+rmRandInt(1,4)));
   LayerVolcanic(id,6);
   rmAddAreaToClass(id,classVolcano);
   int myLavaFlow4 = id;
   rmBuildAllAreas();

   id = CreateAreaAtXZ(ObjName+"Stack", MyAtX,MyAtZ, VolcanoFraction, VolcanoFraction, 2, 1);
   rmSetAreaWarnFailure(id, false);
   rmAddAreaConstraint(id,avoidMapEdgesMedium);
   rmSetAreaTerrainType(id,"Hades"+iifF(MyBright==0,5,7));
   rmSetAreaBaseHeight(id,Height);
   BlobulateArea(id, 2, MinBlobDist, 5, MaxBlobDist);
   rmSetAreaSize(id,VolcanoFraction * rmRandFloat(1-SizeVariance,1),VolcanoFraction * rmRandFloat(1-SizeVariance,1));
   rmAddAreaTerrainLayer(id,"Hades"+iifF(MyBright==0,3,4),0,1);
   rmAddAreaTerrainLayer(id,"Hades"+iifF(MyBright==0,4,5),1,2);
   int myStack = id;
   rmAddAreaToClass(id,classVolcano);
   rmBuildArea(id);

   id = CreateAreaAtXZ(ObjName+"TheHole", MyAtX,MyAtZ, HoleFraction,HoleFraction, 1, 1);
   rmSetAreaWarnFailure(id, false);
   rmAddAreaConstraint(id,avoidMapEdgesMedium);
   rmSetAreaTerrainType(id,"black");
//   rmSetAreaTerrainType(id,"HadesBuildable1");
//   rmAddAreaTerrainLayer(id,"Hades7",0,.2);
   rmSetAreaBaseHeight(id,Height-HoleDepth);
   rmSetAreaLocation(id,MyAtX,MyAtZ);
   rmAddAreaToClass(id,classVolcano);
   rmBuildArea(id);
   if (Embellish>0) {
      int Embell1=rmRandInt(1,5);
      int Embell2=rmRandInt(1,5);
      int Embell3=rmRandInt(1,5);
      int Embell4=rmRandInt(1,5);

      if (OnIsland==2) { // ONLY PLACE ON LARGE MAP TO KEEP SMALL MAP MORE FAIR
         id=rmCreateObjectDef("volcanogiant"+ObjName);
         rmAddObjectDefItem(id, "Fire Giant", 1, 0.0); // FUN STUFF
         rmPlaceObjectDefAtLoc(id, 0, MyAtX, MyAtZ, 1);
      }
      id=rmCreateObjectDef("volcanofire"+ObjName);
      rmAddObjectDefItem(id, "hades fire", 1, 1.0);
//      rmAddObjectDefItem(id, "underworld explosion", 1, 1.0);
      rmPlaceObjectDefAtLoc(id, 0, MyAtX, MyAtZ, 1);
      seterupt(thiserupt, id);

      id=rmCreateObjectDef("volcanobubble"+ObjName);
      rmAddObjectDefItem(id, "lava bubbling", 1, 1.0);
      rmPlaceObjectDefAtLoc(id, 0, MyAtX, MyAtZ, 1);
      if (Embell1==1) rmPlaceObjectDefInArea(id, 0, myLavaFlow1, 1);
      if (Embell2==1) rmPlaceObjectDefInArea(id, 0, myLavaFlow2, 1);
      if (Embell3==1) rmPlaceObjectDefInArea(id, 0, myLavaFlow3, 1);
      if (Embell4==1) rmPlaceObjectDefInArea(id, 0, myLavaFlow4, 1);

      id=rmCreateObjectDef("volcanosmoke"+ObjName);
      rmAddObjectDefItem(id, "smoke giant", 1, 1.0);
      rmPlaceObjectDefAtLoc(id, 0, MyAtX, MyAtZ, 1);
      if (Embell1==1 && rmRandInt(1,5)==1) rmPlaceObjectDefInArea(id, 0, myLavaFlow1, 1);
      if (Embell2==1 && rmRandInt(1,5)==1) rmPlaceObjectDefInArea(id, 0, myLavaFlow2, 1);
      if (Embell3==1 && rmRandInt(1,5)==1) rmPlaceObjectDefInArea(id, 0, myLavaFlow3, 1);
      if (Embell4==1 && rmRandInt(1,5)==1) rmPlaceObjectDefInArea(id, 0, myLavaFlow4, 1);

      id = rmCreateObjectDef("GoldDwarven"+ObjName);
      rmAddObjectDefItem(id,"Gold Mine Dwarven",rmRandInt(1,3),4);
      rmAddObjectDefConstraint(id, avoidBuildingsMedium);
      rmAddObjectDefConstraint(id, avoidGoldShort);

      if (rmRandInt(1,2)==1) rmPlaceObjectDefInArea(id, 0, myLavaFlow1, 1);
      if (rmRandInt(1,2)==1) rmPlaceObjectDefInArea(id, 0, myLavaFlow2, 1);
      if (rmRandInt(1,2)==1) rmPlaceObjectDefInArea(id, 0, myLavaFlow3, 1);
      if (rmRandInt(1,2)==1) rmPlaceObjectDefInArea(id, 0, myLavaFlow4, 1);
      seterupt(thiserupt, id);
   }
}

float MoveTowardCenter(float x=0, float dist=0) {
   float oneside = rmZFractionToTiles(1);
//   rmEchoInfo("Oneside = " + oneside);
   if (x < oneside) {
      x = x + dist;
   } else {
      x = x - dist;
   }
   return (x);
}

void WallopArea(string loc="0,0,0", string powername="") {
   if (powername=="") {
      int i = rmRandInt(1,2); // NO FIRE
      if (i==1) powername = "Earthquake";
      if (i==2) powername = "Meteor";
      if (i==3) powername = "Forest Fire";
   }
   rmAddTriggerEffect("Grant God Power");
   rmSetTriggerEffectParamInt("PlayerID",0);
   rmSetTriggerEffectParam("PowerName","Vision");
   rmSetTriggerEffectParamInt("Count",1);
   rmAddTriggerEffect("Invoke God Power");
   rmSetTriggerEffectParamInt("PlayerID",0);
   rmSetTriggerEffectParam("PowerName","Vision");
   rmSetTriggerEffectParam("DstPoint1",loc);
   rmAddTriggerEffect("Grant God Power");
   rmSetTriggerEffectParamInt("PlayerID",0);
   rmSetTriggerEffectParam("PowerName",powername);
   rmSetTriggerEffectParamInt("Count",1);
   rmAddTriggerEffect("Invoke God Power");
   rmSetTriggerEffectParamInt("PlayerID",0);
   rmSetTriggerEffectParam("PowerName",powername);
   rmSetTriggerEffectParam("DstPoint1",loc);
}



void main(void) {
/* CONSTANTS ************************************/
   int myTiles = iifF(cMapSize==0,8000,20000);
   int mySize = 2 * sqrt(cNumberPlayers * myTiles);
   MapSkin = rmRandInt(1,100);  // I don't like hades,so only do it rarely, very.
   if (MapSkin>5) MapSkin = rmRandInt(1,4);
//   MapSkin=4;
   SeaOrLand=1;
   WaterOnMap=1;
   OnIsland=cMapSize+1;
   float pct=1.0;

   rmSetStatusText("",pct);
   pct = pct-0.05;

   float MyAtX=0;
   float MyAtZ=0;
   string str="";
   int id=0;
   rmSetMapSize(mySize,mySize); // METERS
   rmSetSeaLevel(SeaLevel);
   rmSetSeaType(GetSeaType());
   if (SeaOrLand==0) rmTerrainInitialize(GetLandType());
   else rmTerrainInitialize("water");

   // Define some classes.
   int classTownCenters=rmDefineClass("classTownCenters");
   int classPlayer=rmDefineClass("classPlayer");
   int classCliffs=rmDefineClass("classCliffs");
   int classVolcano=rmDefineClass("classVolcano");
   int classLand=rmDefineClass("classLand");
   int classForest=rmDefineClass("classForest");
   int classLakes=rmDefineClass("classLakes");
   int classAnimals=rmDefineClass("classAnimals");

   // Keep Things Off The Map Edges
   avoidMapEdgesVeryShort=rmCreateBoxConstraint("Avoid Edge Very Short", rmXTilesToFraction(avoidMapEdgesVeryShort), rmZTilesToFraction(avoidMapEdgesVeryShort), 1.0-rmXTilesToFraction(avoidMapEdgesVeryShort), 1.0-rmZTilesToFraction(avoidMapEdgesVeryShort),0.01);
   avoidMapEdgesShort=rmCreateBoxConstraint("Avoid Edge Short", rmXTilesToFraction(avoidMapEdgesShort), rmZTilesToFraction(avoidMapEdgesShort), 1.0-rmXTilesToFraction(avoidMapEdgesShort), 1.0-rmZTilesToFraction(avoidMapEdgesShort),0.01);
   avoidMapEdgesMedium=rmCreateBoxConstraint("Avoid Edge Medium", rmXTilesToFraction(avoidMapEdgesMedium), rmZTilesToFraction(avoidMapEdgesMedium), 1.0-rmXTilesToFraction(avoidMapEdgesMedium), 1.0-rmZTilesToFraction(avoidMapEdgesMedium),0.01);
   avoidMapEdgesLong=rmCreateBoxConstraint("Avoid Edge Long", rmXTilesToFraction(avoidMapEdgesLong), rmZTilesToFraction(avoidMapEdgesLong), 1.0-rmXTilesToFraction(avoidMapEdgesLong), 1.0-rmZTilesToFraction(avoidMapEdgesLong),0.01);
   avoidMapEdgesVeryLong=rmCreateBoxConstraint("Avoid Edge VeryLong", rmXTilesToFraction(avoidMapEdgesVeryLong), rmZTilesToFraction(avoidMapEdgesVeryLong), 1.0-rmXTilesToFraction(avoidMapEdgesVeryLong), 1.0-rmZTilesToFraction(avoidMapEdgesVeryLong),0.01);

      // Used For Various Land Masses
   avoidLandAreaShort=rmCreateClassDistanceConstraint("Avoid Other Land Short", classLand, avoidLandAreaShort);
   avoidLandAreaMedium=rmCreateClassDistanceConstraint("Avoid Other Land Medium", classLand, avoidLandAreaMedium);
   avoidLandAreaLong=rmCreateClassDistanceConstraint("Avoid Other Land Long", classLand, avoidLandAreaLong);

      // Used For Various Cliffs/Gorges
   avoidCliffsGorgesShort=rmCreateClassDistanceConstraint("Avoid CliffsGorges Short", classCliffs, avoidCliffsGorgesShort);
   avoidCliffsGorgesMedium=rmCreateClassDistanceConstraint("Avoid CliffsGorges Medium", classCliffs, avoidCliffsGorgesMedium);
   avoidCliffsGorgesLong=rmCreateClassDistanceConstraint("Avoid CliffsGorges Long", classCliffs, avoidCliffsGorgesLong);

      // Animals
   avoidAnimalsShort=rmCreateClassDistanceConstraint("Avoid Other Animals Short", classAnimals, avoidAnimalsShort);
   avoidAnimalsMedium=rmCreateClassDistanceConstraint("Avoid Other Animals Medium", classAnimals, avoidAnimalsMedium);
   avoidAnimalsLong=rmCreateClassDistanceConstraint("Avoid Other Animals Long", classAnimals, avoidAnimalsLong);

      // Player Areas Constraint
   avoidPlayerAreasVeryShort=rmCreateClassDistanceConstraint("Avoid Players Areas VeryShort", classPlayer, avoidPlayerAreasVeryShort);
   avoidPlayerAreasShort=rmCreateClassDistanceConstraint("Avoid Players Areas Short", classPlayer, avoidPlayerAreasShort);
   avoidPlayerAreasMedium=rmCreateClassDistanceConstraint("Avoid Players Areas Medium", classPlayer, avoidPlayerAreasMedium);
   avoidPlayerAreasLong=rmCreateClassDistanceConstraint("Avoid Players Areas Long", classPlayer, avoidPlayerAreasLong);
   avoidPlayerAreasVeryLong=rmCreateClassDistanceConstraint("Avoid Players Areas VeryLong", classPlayer, avoidPlayerAreasVeryLong);

      // Lakes Constraint
   avoidLakesVeryShort=rmCreateClassDistanceConstraint("Avoid Lakes VeryShort", classLakes, avoidLakesVeryShort);
   avoidLakesShort=rmCreateClassDistanceConstraint("Avoid Lakes Short", classLakes, avoidLakesShort);
   avoidLakesMedium=rmCreateClassDistanceConstraint("Avoid Lakes Medium", classLakes, avoidLakesMedium);
   avoidLakesLong=rmCreateClassDistanceConstraint("Avoid Lakes Long", classLakes, avoidLakesLong);
   avoidLakesVeryLong=rmCreateClassDistanceConstraint("Avoid Lakes VeryLong", classLakes, avoidLakesVeryLong);

      // Town Centers constraint.
   avoidTownCentersShort=rmCreateClassDistanceConstraint("avoid TownCenters Short", classTownCenters, avoidTownCentersShort);
   avoidTownCentersMedium=rmCreateClassDistanceConstraint("avoid TownCenters Medium", classTownCenters, avoidTownCentersMedium);
   avoidTownCentersLong=rmCreateClassDistanceConstraint("avoid TownCenters Long", classTownCenters, avoidTownCentersLong);

      // Building constraints - Used For Additoinal Settlements
   avoidBuildingsShort=rmCreateTypeDistanceConstraint("Avoid Buildings Short", "Building", avoidBuildingsShort);
   avoidBuildingsMedium=rmCreateTypeDistanceConstraint("Avoid Buildings Medium", "Building", avoidBuildingsMedium);
   avoidBuildingsLong=rmCreateTypeDistanceConstraint("Avoid Buildings Long", "Building", avoidBuildingsLong);
   avoidBuildingsVeryLong=rmCreateTypeDistanceConstraint("Avoid Buildings VeryLong", "Building", avoidBuildingsVeryLong);

      // Gold
   avoidGoldShort=rmCreateTypeDistanceConstraint("avoid Gold Short", "gold", avoidGoldShort);
   avoidGoldMedium=rmCreateTypeDistanceConstraint("avoid Gold Medium", "gold", avoidGoldMedium);
   avoidGoldLong=rmCreateTypeDistanceConstraint("avoid Gold Long", "gold", avoidGoldLong);

      // Relics
   avoidRelicShort=rmCreateTypeDistanceConstraint("avoid Relics Short", "relic", avoidRelicShort);
   avoidRelicMedium=rmCreateTypeDistanceConstraint("avoid Relics Medium", "relic", avoidRelicMedium);
   avoidRelicLong=rmCreateTypeDistanceConstraint("avoid Relics Long", "relic", avoidRelicLong);

      // Avoid impassable land
   avoidImpassableLandShort=rmCreateTerrainDistanceConstraint("Avoid Impassable Land Short", "land", false, avoidImpassableLandShort);
   avoidImpassableLandMedium=rmCreateTerrainDistanceConstraint("Avoid Impassable Land Medium", "land", false, avoidImpassableLandMedium);
   avoidImpassableLandLong=rmCreateTerrainDistanceConstraint("Avoid Impassable Land Long", "land", false, avoidImpassableLandLong);

      // Forests
   avoidForestShort=rmCreateClassDistanceConstraint("Avoid Forest Short", classForest, avoidForestShort);
   avoidForestMedium=rmCreateClassDistanceConstraint("Avoid Forest Medium", classForest, avoidForestMedium);
   avoidForestLong=rmCreateClassDistanceConstraint("Avoid Forest Long", classForest, avoidForestLong);

      // Avoid Water
   avoidWaterVeryShort=rmCreateTerrainDistanceConstraint("avoid water very short", "land", false, avoidWaterVeryShort);
   avoidWaterShort=rmCreateTerrainDistanceConstraint("avoid water short", "land", false, avoidWaterShort);
   avoidWaterMedium=rmCreateTerrainDistanceConstraint("avoid water medium", "land", false, avoidWaterMedium);
   avoidWaterLong=rmCreateTerrainDistanceConstraint("avoid water Long", "land", false, avoidWaterLong);

   // Near To Water
   nearShoreLineVeryShort=rmCreateTerrainMaxDistanceConstraint("near shoreline very short", "water", true, nearShoreLineVeryShort);
   nearShoreLineShort=rmCreateTerrainMaxDistanceConstraint("near shoreline short", "water", true, nearShoreLineShort);
   nearShoreLineMedium=rmCreateTerrainMaxDistanceConstraint("near shoreline medium", "water", true, nearShoreLineMedium);
   nearShoreLineLong=rmCreateTerrainMaxDistanceConstraint("near shoreline long", "water", true, nearShoreLineLong);

   // Near To Land
   nearLandVeryShort=rmCreateTerrainMaxDistanceConstraint("near Land very short", "land", true, nearLandVeryShort);
   nearLandShort=rmCreateTerrainMaxDistanceConstraint("near Land short", "land", true, nearLandShort);
   nearLandMedium=rmCreateTerrainMaxDistanceConstraint("near Land medium", "land", true, nearLandMedium);
   nearLandLong=rmCreateTerrainMaxDistanceConstraint("near Land long", "land", true, nearLandLong);

      // Avoid All Objects
   avoidAllVeryShort=rmCreateTypeDistanceConstraint("avoid all very short", "all", avoidAllVeryShort);
   avoidAllShort=rmCreateTypeDistanceConstraint("avoid all short", "all", avoidAllShort);
   avoidAllMedium=rmCreateTypeDistanceConstraint("avoid all medium", "all", avoidAllMedium);
   avoidAllLong=rmCreateTypeDistanceConstraint("avoid all long", "all", avoidAllLong);

      // Volcanos Areas Constraint
   int avoidVolcanosVeryShort=rmCreateClassDistanceConstraint("Avoid Volcanos Areas VeryShort", classVolcano, cVeryShort);
   int avoidVolcanosShort=rmCreateClassDistanceConstraint("Avoid Volcanos Areas Short", classVolcano, cShort);
   int avoidVolcanosMedium=rmCreateClassDistanceConstraint("Avoid Volcanos Areas Medium", classVolcano, cMedium);
   int avoidVolcanosLong=rmCreateClassDistanceConstraint("Avoid Volcanos Areas Long", classVolcano, cLong);

   // Keep Off Shore
   int avoidLandShoreLineShort = rmCreateTerrainDistanceConstraint("avoidLandShoreLine", "land", true, cShort);

   rmSetStatusText("",pct);
   pct = pct-0.05;

   // -------------Define objects
   idTree1=rmCreateObjectDef("random tree1"); // SCATTER RANDOM TREES
   rmAddObjectDefItem(idTree1, GetTreeType(0), 3, 1);
   idTree2=rmCreateObjectDef("random tree2"); // SCATTER RANDOM TREES
   rmAddObjectDefItem(idTree2, GetTreeType(0), 3, 1);
   idTree3=rmCreateObjectDef("random tree3"); // SCATTER RANDOM TREES
   rmAddObjectDefItem(idTree3, GetTreeType(0), 3, 1);
   idTree4=rmCreateObjectDef("random tree"); // SCATTER RANDOM TREES
   rmAddObjectDefItem(idTree4, GetTreeType(0), 3, 1);
   rmAddObjectDefConstraint(idTree1, avoidAllVeryShort);
   rmAddObjectDefConstraint(idTree2, avoidAllVeryShort);
   rmAddObjectDefConstraint(idTree3, avoidAllVeryShort);
   rmAddObjectDefConstraint(idTree4, avoidAllVeryShort);
   rmAddObjectDefConstraint(idTree1, avoidBuildingsShort);
   rmAddObjectDefConstraint(idTree2, avoidBuildingsShort);
   rmAddObjectDefConstraint(idTree3, avoidBuildingsShort);
   rmAddObjectDefConstraint(idTree4, avoidBuildingsShort);
   rmAddObjectDefConstraint(idTree1, avoidVolcanosVeryShort);
   rmAddObjectDefConstraint(idTree2, avoidVolcanosVeryShort);
   rmAddObjectDefConstraint(idTree3, avoidVolcanosVeryShort);
   rmAddObjectDefConstraint(idTree4, avoidVolcanosVeryShort);

   // -------------Done defining objects

   rmSetStatusText("",pct);
   pct = pct-0.05;

   if (OnIsland==2) rmSetTeamSpacingModifier(0.33); //30
   else rmSetTeamSpacingModifier(0.60);
   rmPlacePlayersSquare(0.5-rmXTilesToFraction(30), 10.0, 10.0);
   rmSetStatusText("",pct);
   pct = pct-0.05;
    // PLAYER AREAS
   float playerFraction=rmAreaTilesToFraction(iifF(cMapSize==0,1000,2000));
   for(i=1; <cNumberPlayers) {
      id = CreateAreaAtXZ("Player"+i, -1, -1, playerFraction, playerFraction, 2.0, 0);
      SetMainLandType(id, 6, SeaLevel+2.0);
      rmAddAreaToClass(id, classPlayer);
      rmSetPlayerArea(i, id);
      if (OnIsland==2) BlobulateArea(id, 1,3,rmRandInt(18,21),rmRandInt(21,24));
      rmSetAreaSmoothDistance(id, 10);
      if (OnIsland==1) rmAddAreaConstraint(id, avoidPlayerAreasShort);
      else rmAddAreaConstraint(id, avoidPlayerAreasVeryShort);
      rmAddAreaConstraint(id, avoidMapEdgesMedium);
      rmSetAreaLocPlayer(id, i);
      rmBuildArea(id);
   }

   if (OnIsland==2) {
     // Create team connections
      id=rmCreateConnection("teamswallows");
      rmSetConnectionType(id, cConnectAllies, false, 1.0);
      rmSetConnectionWarnFailure(id, false);
      rmSetConnectionWidth(id, rmRandInt(24,48), rmRandInt(5,10));
      rmSetConnectionCoherence(id,0);
      rmSetConnectionBaseHeight(id, SeaLevel+.15);
      rmSetConnectionHeightBlend(id, 2.0);
      rmSetConnectionSmoothDistance(id, 3.0);
      rmAddConnectionToClass(id, classPlayer);
      //ReplaceWaterWithLand(id);
      rmBuildConnection(id);
   }
   rmSetStatusText("",pct);
   pct = pct-0.05;

   // MAIN LAND
   float MainLandMinSize=iifF(OnIsland==1,.45,.3);
   float MainLandMaxSize=iifF(OnIsland==1,.6,.5);
   id = CreateAreaAtXZ("Center", .5, .5, rmRandFloat(MainLandMinSize,MainLandMaxSize), rmRandFloat(MainLandMinSize,MainLandMaxSize), 2.0, 0);
   SetMainLandType(id, 20, SeaLevel+2.0);
   rmSetAreaSmoothDistance(id, 12);
   if (OnIsland==2) rmAddAreaConstraint(id, avoidPlayerAreasMedium);
   rmAddAreaConstraint(id, avoidMapEdgesShort);
   rmBuildAllAreas();

   int NumCliffs = 5;
   MakeVolcano("Volcano0", 15, rmRandInt(400,500), .15, 8, 1, 1, .5, .5, classVolcano);
   rmSetStatusText("",pct);
   pct = pct-0.05;

   id=rmAddFairLoc("Volcanos", true, true, rmZFractionToMeters(.2), rmZFractionToMeters(.9), cMedium, cLong, false, false);
   rmAddFairLocConstraint(id, avoidPlayerAreasVeryLong);
   rmAddFairLocConstraint(id, avoidImpassableLandShort);
//   rmAddFairLocConstraint(id, avoidMapEdgesLong);
   rmAddFairLocConstraint(id, avoidVolcanosLong);
   id=rmAddFairLoc("Volcanos2", true, true, rmZFractionToMeters(.2), rmZFractionToMeters(.9), cMedium, cLong, false, false);
   rmAddFairLocConstraint(id, avoidPlayerAreasVeryLong);
   rmAddFairLocConstraint(id, avoidImpassableLandShort);
//   rmAddFairLocConstraint(id, avoidMapEdgesLong);
   rmAddFairLocConstraint(id, avoidVolcanosLong);

   if(rmPlaceFairLocs()) {
      for(i=1; <cNumberPlayers) {
         for(fk=0; <rmGetNumberFairLocs(i))
            MyAtX=rmFairLocXFraction(i, fk);
            MyAtZ=rmFairLocZFraction(i, fk);
            if (thiserupt<12) MakeVolcano("Volcano"+i+"_"+fk, rmRandInt(13,15), rmRandInt(300,400), .15, 8, rmRandInt(0,1), 1, MyAtX, MyAtZ,classVolcano);
      }
   }
   rmSetStatusText("",pct);
   pct = pct-0.05;

   if (rmRandInt(1,2)==1) {
      rmSetStatusText("and created Lakes...",0.15);
      int WaterAreaSize = rmRandInt(10,20);
      WaterArea("Lakes",rmRandInt(4,cNumberPlayers+2),5,WaterAreaSize,WaterAreaSize/5, WaterAreaSize/2, classLakes, avoidMapEdgesShort, avoidPlayerAreasShort, avoidVolcanosShort);
      WaterOnMap=1;
   }
   CliffArea("Cliffs",NumCliffs,4,7,rmRandInt(5,10),rmRandInt(5,10), classLand, avoidImpassableLandMedium, avoidPlayerAreasMedium);
   rmSetStatusText("",pct);
   pct = pct-0.05;
   LandArea("NooksCranies",cNumberPlayers*5,-5,5,5,rmRandInt(5,10), classLand, 0, avoidImpassableLandShort, avoidPlayerAreasShort);
   rmSetStatusText("",pct);
   pct = pct-0.05;
   ForestArea("ForestLarge",cNumberPlayers*2,5,rmRandInt(5,10), classForest, avoidPlayerAreasShort, avoidForestMedium, avoidVolcanosShort);
   ForestArea("ForestSmall",cNumberPlayers*2,5,rmRandInt(2,5), classForest, avoidPlayerAreasShort, avoidForestMedium, avoidVolcanosShort);
   rmSetStatusText("",pct);
   pct = pct-0.05;

   // TC
   int TownCenterId=rmCreateObjectDef("TownCenter");
   rmAddObjectDefItem(TownCenterId, "Settlement Level 1", 1, 0.0);
   rmAddObjectDefToClass(TownCenterId, classTownCenters);
   rmSetObjectDefMinDistance(TownCenterId, 0.0);
   rmSetObjectDefMaxDistance(TownCenterId, 13.0);
   rmAddObjectDefConstraint(TownCenterId, avoidWaterShort);
   rmPlaceObjectDefPerPlayer(TownCenterId, true);
   if (OnIsland>0) { // NOT ON ISLAND NEED TOWERS
      // Towers
      int TowerId=rmCreateObjectDef("Tower");
      rmAddObjectDefItem(TowerId, "tower", 1, 0.0);
      rmSetObjectDefMinDistance(TowerId, 15.0);
      rmSetObjectDefMaxDistance(TowerId, 35.0);
      rmAddObjectDefConstraint(TowerId, avoidWaterShort);
      rmAddObjectDefConstraint(TowerId, avoidBuildingsMedium);
      rmPlaceObjectDefPerPlayer(TowerId, true, 4/OnIsland);
    }
   rmSetStatusText("",pct);
   pct = pct-0.05;

   // Settlements
   int SettlementId=rmCreateObjectDef("far settlement");
   rmAddObjectDefItem(SettlementId, "Settlement", 1, 0.0);
   rmAddObjectDefConstraint(SettlementId, avoidMapEdgesShort);
   if (OnIsland==2) { // GIVE EXTRA SETTLEMENTS TO ISLAND GAMES
      rmAddObjectDefConstraint(SettlementId, nearShoreLineLong);
      rmAddObjectDefConstraint(SettlementId, avoidBuildingsMedium); // other settlements
      rmSetObjectDefMinDistance(SettlementId, 35);
      rmSetObjectDefMaxDistance(SettlementId, 100);
      rmPlaceObjectDefPerPlayer(SettlementId, false,1);
      rmAddObjectDefConstraint(SettlementId, avoidPlayerAreasShort);
      rmAddObjectDefConstraint(SettlementId, avoidBuildingsVeryLong); // other settlements
   } else rmAddObjectDefConstraint(SettlementId, avoidBuildingsLong); // other settlements

   rmSetObjectDefMinDistance(SettlementId, rmZFractionToMeters(.2));
   rmSetObjectDefMaxDistance(SettlementId, rmZFractionToMeters(.3));
   rmPlaceObjectDefPerPlayer(SettlementId, false ,1);
   rmSetObjectDefMinDistance(SettlementId, rmZFractionToMeters(.3));
   rmSetObjectDefMaxDistance(SettlementId, rmZFractionToMeters(.4));


   rmSetStatusText("",pct);
   pct = pct-0.05;

   // Transports
   if (OnIsland==2) { // LARGE MAPS GET TRANSPORTS
      int transportGreekID=rmCreateObjectDef("transport Greek");
      rmAddObjectDefItem(transportGreekID, "transport ship Greek", 1, 0.0);
      rmSetObjectDefMinDistance(transportGreekID, 0.0);
      rmSetObjectDefMaxDistance(transportGreekID, 45.0);
      rmAddObjectDefConstraint(transportGreekID, nearShoreLineShort);
      rmAddObjectDefConstraint(transportGreekID, avoidMapEdgesShort);
      int transportNorseID=rmCreateObjectDef("transport Norse");
      rmAddObjectDefItem(transportNorseID, "transport ship Norse", 1, 0.0);
      rmSetObjectDefMinDistance(transportNorseID, 0.0);
      rmSetObjectDefMaxDistance(transportNorseID, 45.0);
      rmAddObjectDefConstraint(transportNorseID, nearShoreLineShort);
      rmAddObjectDefConstraint(transportNorseID, avoidMapEdgesShort);
      int transportEgyptianID=rmCreateObjectDef("transport Egyptian");
      rmAddObjectDefItem(transportEgyptianID, "transport ship Egyptian", 1, 0.0);
      rmSetObjectDefMinDistance(transportEgyptianID, 0.0);
      rmSetObjectDefMaxDistance(transportEgyptianID, 45.0);
      rmAddObjectDefConstraint(transportEgyptianID, nearShoreLineShort);
      rmAddObjectDefConstraint(transportEgyptianID, avoidMapEdgesShort);
      for(i=0; <cNumberPlayers) {
         if(rmGetPlayerCulture(i) == cCultureGreek) rmPlaceObjectDefAtLoc(transportGreekID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
         else if(rmGetPlayerCulture(i) == cCultureNorse) rmPlaceObjectDefAtLoc(transportNorseID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
         else if(rmGetPlayerCulture(i) == cCultureEgyptian) rmPlaceObjectDefAtLoc(transportEgyptianID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
      }
   }
   rmSetStatusText("",pct);
   pct = pct-0.05;

   // FOOD UP THE MAP - - HerdHuntFishPred
   int NotTooMuch=iifF(cNumberPlayers>5,2.0,1.0); // IF LOTS OF PLAYERS USE LESS EYE-CANDY/FOOD
   int HuntFoodGroups=1+rmRandInt(0,1);
   int HerdFoodGroups=1+rmRandInt(0,1);
   // REAL CLOSE HERD FOOD
   for(i=1; <=(HerdFoodGroups)) {
      id = CreateAnimals("closeHerd"+i, 1, 15, 18, classAnimals);
      rmPlaceObjectDefPerPlayer(id, false, 1);
   }
   // NEAR HERD FOOD
   for(i=1; <=(HerdFoodGroups)) {
      id = CreateAnimals("nearHerd"+i, 1, rmZFractionToMeters(.2), rmZFractionToMeters(.33), classAnimals, avoidMapEdgesMedium, avoidForestMedium);
      rmPlaceObjectDefPerPlayer(id, false, 1);
   }
   // FAR HERD FOOD
   for(i=1; <=HerdFoodGroups/NotTooMuch) {
      id = CreateAnimals("farHerd"+i, 1, rmZFractionToMeters(.33), rmZFractionToMeters(.49), classAnimals, avoidMapEdgesMedium, avoidForestMedium, avoidPlayerAreasLong);
      rmPlaceObjectDefPerPlayer(id, false, 1);
   }
   rmSetStatusText("",pct);
   pct = pct-0.05;
   // REAL CLOSE HUNTABLE FOOD
   for(i=1; <=(HuntFoodGroups)) {
      id = CreateAnimals("closeHunt"+i, 2,  15,25, classAnimals);
      rmPlaceObjectDefPerPlayer(id, false, 1);
   }
   // NEAR BY HUNTABLE FOOD
   for(i=1; <=(HuntFoodGroups)) {
      id = CreateAnimals("nearHunt"+i, 2, rmZFractionToMeters(.2), rmZFractionToMeters(.33), classAnimals);
      rmPlaceObjectDefPerPlayer(id, false, 1);
   }
   // FAR AWAY HUNTABLE FOOD
   for(i=1; <=HuntFoodGroups/NotTooMuch) {
      id = CreateAnimals("farHunt"+i, 2, rmZFractionToMeters(.33), rmZFractionToMeters(.495), classAnimals, avoidForestShort, avoidPlayerAreasLong);
      rmPlaceObjectDefPerPlayer(id, false, 1);
   }

   // NEAR BY PREDATORS
   for(i=1; <=rmRandInt(1,2)) {
      id = CreateAnimals("nearPredator"+i, 4, rmZFractionToMeters(.15), rmZFractionToMeters(.25), classAnimals, avoidBuildingsLong, avoidForestShort, avoidAnimalsMedium);
      rmPlaceObjectDefPerPlayer(id, false, 1);
   }
   // FAR AWAY PREDATORS
   for(i=1; <=rmRandInt(1,2)) {
      id = CreateAnimals("farPredator"+i, 4, rmZFractionToMeters(.25), rmZFractionToMeters(.495), classAnimals, avoidBuildingsLong, avoidForestShort,avoidAnimalsMedium);
      rmPlaceObjectDefPerPlayer(id, false, 1);
   }
   if (SeaOrLand==1) { // IF WATER BASED...
      if (OnIsland==2) { // IF PLAYER ON ISLAND, GIVE EXTRA FOODS
         // NEAR BY HERD FOOD
         id = CreateAnimals("nearXHerd", 1, 50, 100, classAnimals, avoidMapEdgesMedium, avoidForestShort);
         rmPlaceObjectDefPerPlayer(id, false, 1);
         // NEAR BY HUNTABLE FOOD
         id = CreateAnimals("nearXHunt", 2, 50, 100, classAnimals,  avoidAnimalsShort, avoidForestShort);
         rmPlaceObjectDefPerPlayer(id, false, 1);
      }
      // REAL CLOSE FISHES
      int NumFishes=rmRandInt(3,4);
      for(i=1; <=NumFishes) {
         id = CreateAnimals("closeFish"+i, 3, 15, 75 * OnIsland, classAnimals, avoidAnimalsMedium);
         rmAddObjectDefConstraint(id, nearShoreLineShort);
         rmPlaceObjectDefPerPlayer(id, false, 1);
      }
      // NEAR TO FAR AWAY FISH FOOD
      for(i=1; <=NumFishes * OnIsland / NotTooMuch) {
         id = CreateAnimals("farFish"+i, 3, 75 * OnIsland, rmZFractionToMeters(.8), classAnimals, avoidAnimalsMedium);
         rmAddObjectDefConstraint(id, nearShoreLineMedium);
         rmPlaceObjectDefPerPlayer(id, false, 1);
      }
   }
   for(i=1; <=cNumberPlayers) {
      str=GetBigFish();
      id=rmCreateObjectDef("bigfish"+str+i);
      rmAddObjectDefItem(id, str, 1, 0.0);
      rmAddObjectDefConstraint(id, avoidLakesVeryShort);
      rmAddObjectDefConstraint(id, avoidMapEdgesShort);
      rmAddObjectDefConstraint(id, avoidLandShoreLineShort);

      rmSetObjectDefMinDistance(id, 0.3);
      rmSetObjectDefMaxDistance(id, rmXFractionToMeters(0.5));
      rmPlaceObjectDefAtLoc(id, 0, 0.5, 0.5, cNumberPlayers / NotTooMuch);
      str="Seaweed";
      id=rmCreateObjectDef("weed"+str+i);
      rmAddObjectDefItem(id, str, 3, 2.0);
      rmAddObjectDefConstraint(id, nearLandShort);
      rmAddObjectDefConstraint(id, avoidLakesVeryShort);
      rmSetObjectDefMinDistance(id, 0.3);
      rmSetObjectDefMaxDistance(id, rmXFractionToMeters(0.5));
      rmPlaceObjectDefAtLoc(id, 0, 0.5, 0.5, cNumberPlayers * 5 / NotTooMuch);
   }

   rmSetStatusText("",pct);
   pct = pct-0.05;

   // GOLD IN THE HILLS
   CreateGold(3000, rmZFractionToMeters(.1), 6000/rmRandInt(1,3)/NotTooMuch, rmZFractionToMeters(.3), 9000/rmRandInt(1,3)/NotTooMuch, rmZFractionToMeters(.5)); // 3 Amount & Distances
   // Relics
   int RelicId=rmCreateObjectDef("relic");
   rmAddObjectDefItem(RelicId, "relic", 1, 0.0);
   rmSetObjectDefMinDistance(RelicId, rmZFractionToMeters(.25));
   rmSetObjectDefMaxDistance(RelicId, rmZFractionToMeters(.45));
   rmAddObjectDefConstraint(RelicId, avoidRelicLong);
   rmAddObjectDefConstraint(RelicId, avoidAllShort);
   rmPlaceObjectDefPerPlayer(RelicId, false, rmRandInt(1,2));
   // Various Rocks
   AddRocks(5*cNumberPlayers, avoidAllVeryShort, avoidPlayerAreasShort);
   rmSetStatusText("",pct);
   pct = pct-0.05;

   // Woody
   for(i=1; <cNumberPlayers) {
      int tid = rmCreateArea("APlayerForest"+i, rmAreaID("Player"+i));
      rmSetAreaWarnFailure(tid, false);
      rmSetAreaSize(tid,playerFraction/10, playerFraction/10);
      rmSetAreaCoherence(tid,0);
      rmAddAreaConstraint(tid, nearShoreLineShort);
      rmAddAreaConstraint(tid, avoidBuildingsShort);
      rmSetAreaForestType(tid,GetTreeType(1));
      rmBuildArea(tid);
   }
   rmSetStatusText("",pct);
   pct = pct-0.05;

   RandomTrees();

  // Text
   rmSetStatusText("",pct);
   pct = pct-0.05;

  // **** TRIGGERS ****

   rmCreateTrigger("egg");
   rmSwitchToTrigger(rmTriggerID("egg"));
   rmAddTriggerCondition("Timer");
   rmSetTriggerConditionParamInt("Param1",1);
   rmAddTriggerEffect("Message");
   rmSetTriggerEffectParam("Text","*** Vesuvius RMS v1 by Cartographer@BeerInHand.com ****");
   if (rmRandInt(1,5)==1) { // Do it only so often to scare em
      rmAddTriggerEffect("Sound Filename");
      rmSetTriggerEffectParam("Sound", "\dialog\skul062.mp3");
   }
   rmSetTriggerPriority(2);
   rmSetTriggerActive(true);
   rmSetTriggerRunImmediately(true);
   rmSetTriggerLoop(false);

/*
   for (i=1;<=thiserupt) {
      id = rmCreateTrigger("blowchunks1_"+i);
      id = rmCreateTrigger("blowchunks2_"+i);
      id = rmCreateTrigger("blowchunks3_"+i);
      id = rmCreateTrigger("blowchunks4_"+i);
      id = rmCreateTrigger("blowchunks5_"+i);
      id = rmCreateTrigger("blowchunks6_"+i);
      id = rmCreateTrigger("shake_"+i);
      id = rmCreateTrigger("spew_"+i);

      rmSwitchToTrigger(rmTriggerID("blowchunks1_"+i));
      rmSetTriggerActive(true);
      rmSetTriggerRunImmediately(true);
      rmSetTriggerLoop(false);
      rmSetTriggerPriority(3);
      rmAddTriggerCondition("Timer");
      rmSetTriggerConditionParamInt("Param1", rmRandInt(240,600), false);
      rmAddTriggerEffect("Sound Filename");
      rmSetTriggerEffectParam("Sound", "rhinodeath.wav");
      rmAddTriggerEffect("Army Change Type");
      rmSetTriggerEffectParamArmy("SrcArmy",0,geterupt(i));
      rmSetTriggerEffectParam("ProtoUnit","Underworld Explosion");
//      rmSetTriggerEffectParam("ProtoUnit","Meteor Impact Ground");

      rmAddTriggerEffect("Fire Event");
      rmSetTriggerEffectParamInt("EventID",rmTriggerID("blowchunks2_"+i));

      rmSwitchToTrigger(rmTriggerID("blowchunks2_"+i));
      rmSetTriggerActive(false);
      rmSetTriggerRunImmediately(false);
      rmSetTriggerLoop(false);
      rmSetTriggerPriority(4);
      rmAddTriggerCondition("Timer");
      rmSetTriggerConditionParamInt("Param1", 8, false);
//      rmAddTriggerEffect("Sound Filename");
//      rmSetTriggerEffectParam("Sound", "firegiantmove1.wav");
      rmAddTriggerEffect("Army Change Type");
      rmSetTriggerEffectParamArmy("SrcArmy",0,geterupt(i));
      rmSetTriggerEffectParam("ProtoUnit","Fire Giant");

      rmAddTriggerEffect("Fire Event");
      rmSetTriggerEffectParamInt("EventID",rmTriggerID("blowchunks3_"+i));

      rmSwitchToTrigger(rmTriggerID("blowchunks3_"+i));
      rmSetTriggerActive(false);
      rmSetTriggerRunImmediately(false);
      rmSetTriggerLoop(false);
      rmSetTriggerPriority(4);
      rmAddTriggerCondition("Timer");
      rmSetTriggerConditionParamInt("Param1", 30, false);
//      rmAddTriggerEffect("Sound Filename");
//      rmSetTriggerEffectParam("Sound", "meteorapproach.wav");
      rmAddTriggerEffect("Army Change Type");
      rmSetTriggerEffectParamArmy("SrcArmy",0,geterupt(i));
      rmSetTriggerEffectParam("ProtoUnit","Meteor Impact Ground");
      rmAddTriggerEffect("Fire Event");
      rmSetTriggerEffectParamInt("EventID",rmTriggerID("blowchunks4_"+i));

      rmSwitchToTrigger(rmTriggerID("blowchunks4_"+i));
      rmSetTriggerActive(false);
      rmSetTriggerRunImmediately(false);
      rmSetTriggerLoop(false);
      rmSetTriggerPriority(4);
      rmAddTriggerCondition("Timer");
      rmSetTriggerConditionParamInt("Param1", 8, false);
      rmAddTriggerEffect("Army Change Type");
      rmSetTriggerEffectParamArmy("SrcArmy",0,geterupt(i));
      rmSetTriggerEffectParam("ProtoUnit","NidHogg");
      rmAddTriggerEffect("Fire Event");
      rmSetTriggerEffectParamInt("EventID",rmTriggerID("blowchunks5_"+i));

      rmSwitchToTrigger(rmTriggerID("blowchunks5_"+i));
      rmSetTriggerActive(false);
      rmSetTriggerRunImmediately(false);
      rmSetTriggerLoop(false);
      rmSetTriggerPriority(4);
      rmAddTriggerCondition("Timer");
      rmSetTriggerConditionParamInt("Param1", 30, false);
//      rmAddTriggerEffect("Sound Filename");
//      rmSetTriggerEffectParam("Sound", "meteorapproach.wav");
      rmAddTriggerEffect("Army Change Type");
      rmSetTriggerEffectParamArmy("SrcArmy",0,geterupt(i));
      rmSetTriggerEffectParam("ProtoUnit","Meteor Impact Ground");
      rmAddTriggerEffect("Fire Event");
      rmSetTriggerEffectParamInt("EventID",rmTriggerID("blowchunks6_"+i));

      rmSwitchToTrigger(rmTriggerID("blowchunks6_"+i));
      rmSetTriggerActive(false);
      rmSetTriggerRunImmediately(false);
      rmSetTriggerLoop(false);
      rmSetTriggerPriority(4);
      rmAddTriggerCondition("Timer");
      rmSetTriggerConditionParamInt("Param1", 6, false);
//      rmAddTriggerEffect("Sound Filename");
//      rmSetTriggerEffectParam("Sound", "hawkgrunt1.wav");
      rmAddTriggerEffect("Army Change Type");
      rmSetTriggerEffectParamArmy("SrcArmy",0,geterupt(i));
      rmSetTriggerEffectParam("ProtoUnit","Harpy");
      rmAddTriggerEffect("Fire Event");
      rmSetTriggerEffectParamInt("EventID",rmTriggerID("shake_"+i));


      rmSwitchToTrigger(rmTriggerID("shake_"+i));
      rmSetTriggerActive(false);
      rmSetTriggerRunImmediately(false);
      rmSetTriggerLoop(false);
      rmSetTriggerPriority(4);
      rmAddTriggerCondition("Timer");
      rmSetTriggerConditionParamInt("Param1", 20, false);
//rmAddTriggerEffect("Send Chat");
//rmSetTriggerEffectParamInt("PlayerID",0);
//rmSetTriggerEffectParam("Message","Volcano"+i+" is erupting @" + geteruptloc(i));

      rmAddTriggerEffect("Army Change Type");
      rmSetTriggerEffectParamArmy("SrcArmy",0,geterupt(i));
      rmSetTriggerEffectParam("ProtoUnit","Gold Mine Dwarven");
      WallopArea(geteruptloc(i),"Earthquake");
      rmAddTriggerEffect("Fire Event");
      rmSetTriggerEffectParamInt("EventID",rmTriggerID("spew_"+i));

      rmSwitchToTrigger(rmTriggerID("spew_"+i));
      rmSetTriggerActive(false);
      rmSetTriggerRunImmediately(false);
      rmSetTriggerLoop(false);
      rmSetTriggerPriority(4);
      rmAddTriggerCondition("Timer");
      rmSetTriggerConditionParamInt("Param1", 20, false);
      WallopArea(geteruptloc(i),"Meteor");
      rmAddTriggerEffect("Fire Event");
      rmSetTriggerEffectParamInt("EventID",rmTriggerID("blowchunks1_"+i));
   }
*/
}